/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Curving Arrow"
#define PL_DESC "CurvingArrow"
#define PL_VERSION "2013.01.27"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_CURVARROW "weapons/fx/nearmiss/bulletltor09.wav"
#define EFFECT_CURARROW_RED "player_dripsred"
#define EFFECT_CURARROW_BLU "player_drips_blue"


/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new g_BowHold[MAXPLAYERS+1] = -1;					// ƏH
new g_Arrow[MAXPLAYERS+1] = -1;						// ˂
new Float:g_ChargeBeginTime[MAXPLAYERS+1] = 0.0;	// ƏJn
new Float:g_ChargeTime[MAXPLAYERS+1] = 0.0;			// `[W
new Float:g_CurvDir[MAXPLAYERS+1][2];				// J[u

/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S


}
/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginEnd()
{
}

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Sniper );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Huntsman", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	AddCustomAttributes( IS_Primary, "aiming movespeed decreased", "0.01");
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEhvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound( SOUND_CURVARROW,	true );
	PrecacheSound( SOUND_CURVARROW,	true );
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// |Ă
	/////////////////////////////////////////////////////////////////////
	g_BowHold[client] = -1;
	
	/////////////////////////////////////////////////////////////////////
	// Ȃ
	/////////////////////////////////////////////////////////////////////
	g_Arrow[client] = -1;
	
	/////////////////////////////////////////////////////////////////////
	// J[uNA
	/////////////////////////////////////////////////////////////////////
	g_CurvDir[client][0] = 0.0;
	g_CurvDir[client][1] = 0.0;
	
	/////////////////////////////////////////////////////////////////////
	// `[WԃNA
	/////////////////////////////////////////////////////////////////////
	g_ChargeBeginTime[client] = 0.0;
	g_ChargeTime[client] = 0.0;
	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// ̃AreBI𒆁H
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{
				/////////////////////////////////////////////////////////////////////
				// \̓ANV
				/////////////////////////////////////////////////////////////////////
				CurvingArrow(client);
			}
		}
	}
}


/////////////////////////////////////////////////////////////////////
//
// AreB̏
//
/////////////////////////////////////////////////////////////////////
public CurvingArrow(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// nc}
	/////////////////////////////////////////////////////////////////////
	if(TF2_CurrentWeaponEqual(client, "CTFCompoundBow"))
	{

		/////////////////////////////////////////////////////////////////////
		// Ə
		/////////////////////////////////////////////////////////////////////
		if(GetClientButtons(client) & IN_ATTACK && GetEntPropFloat(TF2_GetCurrentWeapon(client), Prop_Send, "m_flChargeBeginTime") != 0.0)
		{
			if( CheckElapsedTime(client, 0.1) )
			{			
				/////////////////////////////////////////////////////////////////////
				// L[Ԃۑ
				/////////////////////////////////////////////////////////////////////
				SaveKeyTime(client);

				/////////////////////////////////////////////////////////////////////
				// `[WJnԕۑ
				/////////////////////////////////////////////////////////////////////
				if(g_BowHold[client] == -1)
				{
					g_ChargeBeginTime[client] = GetEntPropFloat(TF2_GetCurrentWeapon(client), Prop_Send, "m_flChargeBeginTime");
				}
				
				/////////////////////////////////////////////////////////////////////
				// Əɐݒ
				/////////////////////////////////////////////////////////////////////
				g_BowHold[client] = 1;
				
				/////////////////////////////////////////////////////////////////////
				// ̃J[uݒ
				/////////////////////////////////////////////////////////////////////
				g_CurvDir[client][0] = 0.0; // Y
				g_CurvDir[client][1] = 0.0; // X
				if(GetClientButtons(client) & IN_MOVELEFT)
				{
					g_CurvDir[client][1] = 1.0;
				}
				if(GetClientButtons(client) & IN_MOVERIGHT)
				{
					g_CurvDir[client][1] = -1.0;
				}
				if(GetClientButtons(client) & IN_FORWARD)
				{
					g_CurvDir[client][0] = -1.0;
				}
				if(GetClientButtons(client) & IN_BACK)
				{
					g_CurvDir[client][0] = 1.0;
				}	
				
			}
		}
		else
		{
			/////////////////////////////////////////////////////////////////////
			// |ˁJ[uݒς݂
			/////////////////////////////////////////////////////////////////////
			if(g_BowHold[client] == 1 && (g_CurvDir[client][0] != 0.0 || g_CurvDir[client][1] != 0.0))
			{
				/////////////////////////////////////////////////////////////////////
				// `[W
				/////////////////////////////////////////////////////////////////////
				g_ChargeTime[client] = GetGameTime() -g_ChargeBeginTime[client];
				
				/////////////////////////////////////////////////////////////////////
				// |
				/////////////////////////////////////////////////////////////////////
				g_Arrow[client] = -1;
				new arrow = -1;
				while ((arrow = FindEntityByClassname(arrow, "tf_projectile_arrow")) != -1)
				{
					/////////////////////////////////////////////////////////////////////
					// ˂vC[`FbN
					/////////////////////////////////////////////////////////////////////
					new iOwner = GetEntPropEnt(arrow, Prop_Send, "m_hOwnerEntity");
					if(iOwner == client)
					{
						/////////////////////////////////////////////////////////////////////
						// ۑ
						/////////////////////////////////////////////////////////////////////
						g_Arrow[client] = arrow;
						
						/////////////////////////////////////////////////////////////////////
						// uIĉ
						/////////////////////////////////////////////////////////////////////
						EmitSoundToAll(SOUND_CURVARROW, arrow, _, _, SND_CHANGEPITCH, 1.0, 40);
						
						/////////////////////////////////////////////////////////////////////
						// ɃGtFNg
						/////////////////////////////////////////////////////////////////////
						if(TFTeam:GetClientTeam(client) == TFTeam_Red)
						{
							SpawnParticle( EFFECT_CURARROW_RED, 0.5, _, arrow);	
							
						}
						else
						{
							SpawnParticle( EFFECT_CURARROW_BLU, 0.5, _, arrow);	
						}
					}
				}
			}

			/////////////////////////////////////////////////////////////////////
			// |\ĂȂ
			/////////////////////////////////////////////////////////////////////
			g_BowHold[client] = -1;
		}
		
		/////////////////////////////////////////////////////////////////////
		// Ȃ
		/////////////////////////////////////////////////////////////////////
		if(g_Arrow[client] != -1 && IsValidEntity(g_Arrow[client]) )
		{
				
			new String:name[64];
			GetEntityNetClass(g_Arrow[client], name, sizeof(name));
			if(StrEqual(name, "CTFProjectile_Arrow") && GetEntityMoveType(g_Arrow[client]) == MOVETYPE_FLYGRAVITY)
			{
				new Float:arrowPos[3];	// ̈ʒu
				new Float:arrowAng[3];	// ̊px
				new Float:arrowVec[3];	// ̕
				new Float:arrowNewVec[3];	// ̕
				
				/////////////////////////////////////////////////////////////////////
				// ̃f[^ǂݍ
				/////////////////////////////////////////////////////////////////////
				GetEntPropVector(g_Arrow[client], Prop_Data, "m_vecAbsOrigin", arrowPos);			// ̈ʒu
				GetEntPropVector(g_Arrow[client], Prop_Data, "m_angRotation", arrowAng);			// ̊px
				GetEntPropVector(g_Arrow[client], Prop_Data, "m_vecAbsVelocity", arrowVec);			// ̕
				
				/////////////////////////////////////////////////////////////////////
				// Ȃpx̓`[WԂɔ
				/////////////////////////////////////////////////////////////////////
				arrowAng[0] += g_CurvDir[client][0] * 0.5 * g_ChargeTime[client];
				arrowAng[1] += g_CurvDir[client][1] * 0.5 * g_ChargeTime[client];
				
				/////////////////////////////////////////////////////////////////////
				// ̐iޕ擾
				/////////////////////////////////////////////////////////////////////
				GetAngleVectors(arrowAng, arrowNewVec, NULL_VECTOR, NULL_VECTOR);
				
				/////////////////////////////////////////////////////////////////////
				// ͂񂾂Ɨ
				/////////////////////////////////////////////////////////////////////
				ScaleVector(arrowNewVec, GetVectorLength(arrowVec));
				arrowNewVec[2] -= 0.9 * (1 / g_ChargeTime[client]);
				
				/////////////////////////////////////////////////////////////////////
				// f[^㏑
				/////////////////////////////////////////////////////////////////////
				SetEntPropVector(g_Arrow[client], Prop_Data, "m_vecAbsVelocity", arrowNewVec);
				
				/////////////////////////////////////////////////////////////////////
				// ̊pxKp
				/////////////////////////////////////////////////////////////////////
				GetVectorAngles(arrowNewVec, arrowAng);
				SetEntPropVector(g_Arrow[client], Prop_Data, "m_angRotation", arrowAng);
			}
			else
			{
				/////////////////////////////////////////////////////////////////////
				// ȂNA
				/////////////////////////////////////////////////////////////////////
				g_CurvDir[client][0] = 0.0;
				g_CurvDir[client][1] = 0.0;
				
				/////////////////////////////////////////////////////////////////////
				// `[WԃNA
				/////////////////////////////////////////////////////////////////////
				g_ChargeTime[client] = 0.0;
				
				/////////////////////////////////////////////////////////////////////
				// NA
				/////////////////////////////////////////////////////////////////////
				g_Arrow[client] = -1;
			}		
		}
	}
}
