/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
// 2013.01.27
// 2013.02.18 - NCAgTimer_Effect̃G[CB
// 2013.09.24 - Pbg擾CB

/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Homing Rocket"
#define PL_DESC "Homing Rocket"
#define PL_VERSION "2013.09.24"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define HOMING_ROCKETS_MAX	8	// z[~OPbgő吔
#define HOMING_START_ACC	70	// X^[gx
#define HOMING_FINAL_ACC	2	// ŏIx
#define MAX_MUSIC			17	// y

/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define MDL_RADIO "models/weapons/c_models/c_battalion_buffpack/c_batt_buffpack.mdl"
#define SOUND_ERROR "weapons/medigun_no_target.wav"
#define SOUND_PICKUP "ui/item_pack_pickup.wav"
#define SOUND_DROP "ui/item_pack_drop.wav"
#define SOUND_BOOT "replay/downloadcomplete.wav"
#define SOUND_OUTBATTERY "replay/downloadfailed.wav"
new String:SOUND_MUSIC[MAX_MUSIC][64];	
#define SPRITE_BEAM "materials/sprites/laser.vmt"
#define SPRITE_HALO "materials/sprites/halo01.vmt"
#define EFFECT_LIGHT_RED	"stickybomb_pulse_red"
#define EFFECT_LIGHT_BLU	"stickybomb_pulse_blue"



/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new g_PlantedRadio[MAXPLAYERS+1] = -1;							// ݒuWI
new Float:g_RadioPos[MAXPLAYERS+1][3];							// WÏʒu
new Handle:g_RemoveRadioTimer[MAXPLAYERS+1] = INVALID_HANDLE;	// WIŃ^C}[
new Handle:g_EffectTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// GtFNg^C}[
new bool:g_Planted[MAXPLAYERS+1] = false;						// ݒutO
new g_RocketsData[MAXPLAYERS+1][HOMING_ROCKETS_MAX];			// Pbgf[^
new g_RocketsCount[MAXPLAYERS+1][HOMING_ROCKETS_MAX];			// PbgJE^
new g_TeamColor[4][4];											// `[J[
new g_BeamSprite;												// GtFNgpXvCg
new g_HaloSprite;												// GtFNgpXvCg
new g_NowMusic[MAXPLAYERS+1];								// ݍĐ̉y

/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
new Handle:g_CVarEffectiveTime	= INVALID_HANDLE;		// ConVarL


/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Soldier );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Battalion's Backup", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	
}

/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarEffectiveTime,	"effective_time",	"60.0",	"Effective Time",	0, "1.0",		"60.0",	FMT_Float);
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S
	

	/////////////////////////////////////////////////////////////////////
	// `[J[ݒ
	/////////////////////////////////////////////////////////////////////
	g_TeamColor[_:TFTeam_Red][0] = 255;
	g_TeamColor[_:TFTeam_Red][1] = 32;
	g_TeamColor[_:TFTeam_Red][2] = 32;
	g_TeamColor[_:TFTeam_Red][3] = 128;
	g_TeamColor[_:TFTeam_Blue][0] = 32;
	g_TeamColor[_:TFTeam_Blue][1] = 32;
	g_TeamColor[_:TFTeam_Blue][2] = 255;
	g_TeamColor[_:TFTeam_Blue][3] = 128;

	/////////////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		g_PlantedRadio[i] = -1;
	}

	/////////////////////////////////////////////////////////////////////
	// WIy
	/////////////////////////////////////////////////////////////////////
	SOUND_MUSIC[0] = "items/tf_music_upgrade_machine.wav";
	SOUND_MUSIC[1] = "ui/gamestartup1.mp3";
	SOUND_MUSIC[2] = "ui/gamestartup2.mp3";
	SOUND_MUSIC[3] = "ui/gamestartup3.mp3";
	SOUND_MUSIC[4] = "ui/gamestartup4.mp3";
	SOUND_MUSIC[5] = "ui/gamestartup5.mp3";
	SOUND_MUSIC[6] = "ui/gamestartup6.mp3";
	SOUND_MUSIC[7] = "ui/gamestartup7.mp3";
	SOUND_MUSIC[8] = "ui/gamestartup8.mp3";
	SOUND_MUSIC[9] = "ui/gamestartup9.mp3";
	SOUND_MUSIC[10] = "ui/gamestartup10.mp3";
	SOUND_MUSIC[11] = "ui/gamestartup11.mp3";
	SOUND_MUSIC[12] = "ui/gamestartup12.mp3";
	SOUND_MUSIC[13] = "ui/gamestartup13.mp3";
	SOUND_MUSIC[14] = "ui/gamestartup14.mp3";
	SOUND_MUSIC[15] = "ui/gamestartup15.mp3";
	SOUND_MUSIC[16] = "ui/gamestartup16.mp3";
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		RemoveRadio(i);
	}
	
	/////////////////////////////////////////////////////////////////////
	// TEh,fvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheModel(MDL_RADIO);
	PrecacheSound(SOUND_ERROR, true);
	PrecacheSound(SOUND_PICKUP, true);
	PrecacheSound(SOUND_DROP, true);
	PrecacheSound(SOUND_BOOT, true);
	for( new i = 0; i < MAX_MUSIC; i++ )
	{
		PrecacheSound(SOUND_MUSIC[i], true);
	}
	PrecacheSound(SOUND_OUTBATTERY, true);
	g_BeamSprite = PrecacheModel(SPRITE_BEAM, true);
	g_HaloSprite = PrecacheModel(SPRITE_HALO, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// L[Ԃۑ
	/////////////////////////////////////////////////////////////////////
	SaveKeyTime(client);	
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	RemoveRadio( client );
	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// AreB
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{			
				/////////////////////////////////////////////////////////////////////
				// AreB
				/////////////////////////////////////////////////////////////////////
				HomingRocket( client );
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// AreB
//
/////////////////////////////////////////////////////////////////////
public HomingRocket( client )
{
	/////////////////////////////////////////////////////////////////////
	// `FbN
	/////////////////////////////////////////////////////////////////////
	// L[`FbN
	if( CheckElapsedTime(client, 0.5) )
	{
		/////////////////////////////////////////////////////////////////////
		// XyVA^bN
		/////////////////////////////////////////////////////////////////////
		if ( GetClientButtons(client) & IN_ATTACK3 )
		{
			/////////////////////////////////////////////////////////////////////
			// L[Ԃۑ
			/////////////////////////////////////////////////////////////////////
			SaveKeyTime(client);
			
			/////////////////////////////////////////////////////////////////////
			// WIݒu
			/////////////////////////////////////////////////////////////////////
			PlantCheck( client );
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// PbgU
	/////////////////////////////////////////////////////////////////////
	if( g_Planted[ client ] && g_RemoveRadioTimer[client] != INVALID_HANDLE )
	{
		/////////////////////////////////////////////////////////////////////
		// f[^o^Ă邩`FbN
		/////////////////////////////////////////////////////////////////////
		for(new i = 0; i < HOMING_ROCKETS_MAX; i++)
		{				
			if( g_RocketsData[client][i] != -1 )
			{
				/////////////////////////////////////////////////////////////////////
				// PbgΗU
				/////////////////////////////////////////////////////////////////////
				if( IsValidEdict( g_RocketsData[client][i] )
					&& ( TF2_EdictNameEqual( g_RocketsData[client][i], "tf_projectile_rocket")
				|| TF2_EdictNameEqual( g_RocketsData[client][i], "tf_projectile_energy_ball" ) ) ) 
				{
					new Float:RocketPos[3];	// Pbg̈ʒu
					new Float:RocketAng[3];	// Pbg̊px
					new Float:RocketVec[3];	// Pbg̕
					new Float:TargetVec[3];		// ^[Qbgւ̕
					new Float:MiddleVec[3];		// ԃxNg

					/////////////////////////////////////////////////////////////////////
					// Pbg̃f[^ǂݍ
					/////////////////////////////////////////////////////////////////////
					GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsOrigin", RocketPos );		// Pbg̈ʒu
					GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_angRotation", RocketAng );		// Pbg̊px
					GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsVelocity", RocketVec );	// Pbg̕

					new Float:RocketSpeed = GetVectorLength( RocketVec ); // Pbg̃Xs[h
					
					/////////////////////////////////////////////////////////////////////
					// Pbgƃ^[Qbg̊px𒲂ׂ
					/////////////////////////////////////////////////////////////////////
					SubtractVectors( g_RadioPos[client], RocketPos, TargetVec );	// ^[Qbg܂ł̕ 
					
					/////////////////////////////////////////////////////////////////////
					// Pbg̐x
					/////////////////////////////////////////////////////////////////////
					AddVectors( RocketVec, TargetVec, MiddleVec );
					for( new j=0; j < g_RocketsCount[client][i]; j++ )
					{
						AddVectors( RocketVec, MiddleVec, MiddleVec );
					}
					AddVectors( RocketVec, MiddleVec, RocketVec );
					
					NormalizeVector( RocketVec, RocketVec );
					
					/////////////////////////////////////////////////////////////////////
					// Pbg̊px㏑
					/////////////////////////////////////////////////////////////////////
					GetVectorAngles( RocketVec, RocketAng );
					SetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_angRotation", RocketAng);

					/////////////////////////////////////////////////////////////////////
					// Pbg̕㏑
					/////////////////////////////////////////////////////////////////////
					ScaleVector( RocketVec, RocketSpeed );
					SetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsVelocity", RocketVec );
					
					if(g_RocketsCount[client][i] > HOMING_FINAL_ACC )
					{
						g_RocketsCount[client][i] -= 1;
					}
						
					/////////////////////////////////////////////////////////////////////
					// Ux߂
					/////////////////////////////////////////////////////////////////////
					g_RocketsCount[client][i]--;
				}
				else
				{
					/////////////////////////////////////////////////////////////////////
					// ɃPbgĂ烊Xg폜
					/////////////////////////////////////////////////////////////////////
					g_RocketsData[client][i] = -1;
					g_RocketsCount[client][i] = HOMING_START_ACC;
				}
			}
		}				
	}
}


/////////////////////////////////////////////////////////////////////
//
// AreB
//
/////////////////////////////////////////////////////////////////////
public PlantCheck( client )
{
	/////////////////////////////////////////////////////////////////////
	// ݒu`FbN
	/////////////////////////////////////////////////////////////////////
	if( !g_Planted[client] )
	{
		/////////////////////////////////////////////////////////////////////
		// nʂɂ鎞̂
		/////////////////////////////////////////////////////////////////////
		if( GetEntityFlags( client ) & FL_ONGROUND )
		{
			/////////////////////////////////////////////////////////////////////
			// WIf쐬
			/////////////////////////////////////////////////////////////////////
			g_PlantedRadio[client] = CreateEntityByName("prop_dynamic");
			if ( IsValidEdict( g_PlantedRadio[client] ) )
			{
				new String:tName[32];
				GetEntPropString(client, Prop_Data, "m_iName", tName, sizeof(tName));
				DispatchKeyValue(g_PlantedRadio[client], "targetname", "sol_radio");
				DispatchKeyValue(g_PlantedRadio[client], "parentname", tName);
				SetEntityModel(g_PlantedRadio[client], MDL_RADIO);
				DispatchSpawn(g_PlantedRadio[client]);

				/////////////////////////////////////////////////////////////////////
				// W
				/////////////////////////////////////////////////////////////////////
				new Float:ang[3];
				GetEntPropVector( client, Prop_Send, "m_vecOrigin", g_RadioPos[client]);
				GetClientEyeAngles(client, ang);			
				g_RadioPos[client][2] -= 57.0;
				ang[0] = 0.0;
				ang[1] += 180.0;
				ang[2] = 0.0;
				
				/////////////////////////////////////////////////////////////////////
				// fvC[̈ʒuɈړ
				/////////////////////////////////////////////////////////////////////
				TeleportEntity(g_PlantedRadio[client], g_RadioPos[client], ang, NULL_VECTOR);
				
				/////////////////////////////////////////////////////////////////////
				// ^C}[
				/////////////////////////////////////////////////////////////////////
				ClearTimer(g_RemoveRadioTimer[client]);	
				g_RemoveRadioTimer[client] = CreateTimer(GetConVarFloat( g_CVarEffectiveTime ), Timer_BatteryOut, client);
				/////////////////////////////////////////////////////////////////////
				// GtFNg[v^C}[ݒ
				/////////////////////////////////////////////////////////////////////
				ClearTimer(g_EffectTimer[client]);
				g_EffectTimer[client] = CreateTimer(1.0, Timer_Effect, client, TIMER_REPEAT);
				
				/////////////////////////////////////////////////////////////////////
				// TEh
				/////////////////////////////////////////////////////////////////////
				EmitSoundToAll(SOUND_DROP, g_PlantedRadio[client]);	
				EmitSoundToAll(SOUND_BOOT, g_PlantedRadio[client]);	
				g_NowMusic[client] = GetRandomInt(0, MAX_MUSIC - 1);
				EmitSoundToAll(SOUND_MUSIC[g_NowMusic[client]], g_PlantedRadio[client], _, _, SND_CHANGEPITCH, 1.0, 100);	

				/////////////////////////////////////////////////////////////////////
				// ݒutO
				/////////////////////////////////////////////////////////////////////
				g_Planted[client] = true;
		    }	
			
			return;
		}
	}
	else
	{
		/////////////////////////////////////////////////////////////////////
		// vC[̈ʒu߂Ή
		/////////////////////////////////////////////////////////////////////
		new Float:pos[3];
		GetEntPropVector( client, Prop_Send, "m_vecOrigin", pos);
		if( GetVectorDistanceMeter( pos, g_RadioPos[client] ) < 1.5 ) 
		{		
			/////////////////////////////////////////////////////////////////////
			// ܂bZ[W
			/////////////////////////////////////////////////////////////////////
			PrintToChat(client, "\x05%T", "MESSAGE_PICKUP", client);
			
			/////////////////////////////////////////////////////////////////////
			// TEh
			/////////////////////////////////////////////////////////////////////
			EmitSoundToAll(SOUND_PICKUP, g_PlantedRadio[client]);	
			
			/////////////////////////////////////////////////////////////////////
			// ݒuWI폜
			/////////////////////////////////////////////////////////////////////
			RemoveRadio( client );
			
			return;
		}
		else
		{
			/////////////////////////////////////////////////////////////////////
			// ȂƐݒułȂbZ[W
			/////////////////////////////////////////////////////////////////////
			PrintToChat(client, "\x05%T", "MESSAGE_NEEDPICKUP", client);
		}
	}	
	
	
	/////////////////////////////////////////////////////////////////////
	// G[
	/////////////////////////////////////////////////////////////////////
	EmitSoundToClient(client, SOUND_ERROR, client, _, _, _, 1.0);
}

/////////////////////////////////////////////////////////////////////
//
// obe[؂
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_BatteryOut(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// bZ[Wƃobe[؂ꉹ
	/////////////////////////////////////////////////////////////////////
	PrintToChat(client, "\x05%T", "MESSAGE_OUTOFBATTERY", client);
	EmitSoundToClient(client, SOUND_OUTBATTERY, client, _, _, _, 1.0);	
	
	g_RemoveRadioTimer[client] = INVALID_HANDLE;
}


/////////////////////////////////////////////////////////////////////
//
// WI폜
//
/////////////////////////////////////////////////////////////////////
public RemoveRadio( client )
{
	/////////////////////////////////////////////////////////////////////
	// ^C}[NA
	/////////////////////////////////////////////////////////////////////
	ClearTimer( g_RemoveRadioTimer[client] );
	ClearTimer( g_EffectTimer[client] );
	
	/////////////////////////////////////////////////////////////////////
	// Tbp[
	/////////////////////////////////////////////////////////////////////
	if(g_PlantedRadio[client] != -1)
	{
		/////////////////////////////////////////////////////////////////////
		// cĂ폜
		/////////////////////////////////////////////////////////////////////
		if(IsValidEntity(g_PlantedRadio[client]))
		{
			/////////////////////////////////////////////////////////////////////
			// TEh~
			/////////////////////////////////////////////////////////////////////
			if( g_NowMusic[client] > -1 )
			{
				StopSound(g_PlantedRadio[client], 0, SOUND_MUSIC[g_NowMusic[client]]);
				g_NowMusic[client] = -1;
			}
			
			/////////////////////////////////////////////////////////////////////
			// 폜
			/////////////////////////////////////////////////////////////////////
			AcceptEntityInput(g_PlantedRadio[client], "Kill");			
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// 낢돉
	/////////////////////////////////////////////////////////////////////
	g_PlantedRadio[client] = -1;
	g_Planted[client] = false
	g_RadioPos[client] = NULL_VECTOR;
	for( new i = 0; i < HOMING_ROCKETS_MAX; i++ )
	{
		g_RocketsData[client][i] = -1;
		g_RocketsCount[client][i] = HOMING_START_ACC;
	}
	

}

/////////////////////////////////////////////////////////////////////
//
// GeBeB쐬
//
/////////////////////////////////////////////////////////////////////
public OnEntityCreated(entity, const String:classname[])
{
	/////////////////////////////////////////////////////////////////////
	// Pbĝ
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( classname, "tf_projectile_rocket") || StrEqual( classname, "tf_projectile_energy_ball") )
	{
	    SDKHook(entity, SDKHook_Spawn, OnEntitySpawned);
	}
}
public OnEntitySpawned(entity)
{
	/////////////////////////////////////////////////////////////////////
	// Pbĝ
	/////////////////////////////////////////////////////////////////////
	if( TF2_EdictNameEqual( entity, "tf_projectile_rocket") || TF2_EdictNameEqual( entity, "tf_projectile_energy_ball") )
	{
		/////////////////////////////////////////////////////////////////////
		// ˂vC[AreBĂ
		/////////////////////////////////////////////////////////////////////
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		if( IsSelectedAbility( client )  )
		{
			if( g_Planted[ client ] && g_RemoveRadioTimer[client] != INVALID_HANDLE )
			{
				/////////////////////////////////////////////////////////////////////
				// f[^o^Ă邩`FbN
				/////////////////////////////////////////////////////////////////////
				for(new i = 0; i < HOMING_ROCKETS_MAX; i++)
				{				
					if( g_RocketsData[client][i] == -1 )
					{
						g_RocketsData[client][i] = entity;
						g_RocketsCount[client][i] = HOMING_START_ACC;
						break;
					}
				}				
			}
		}
	}
	SDKUnhook(entity, SDKHook_Spawn, OnEntitySpawned);
}

/////////////////////////////////////////////////////////////////////
//
// GtFNg^C}[
//
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
//
// [v^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_Effect(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂȂꍇ͍폜
	/////////////////////////////////////////////////////////////////////
	if( !IsClientInGame(client) )
	{
		RemoveRadio( client );
	}
	
	/////////////////////////////////////////////////////////////////////
	// WI
	/////////////////////////////////////////////////////////////////////
	if ( g_PlantedRadio[client] != -1 && IsValidEdict( g_PlantedRadio[client] ) )
	{
		if( g_RemoveRadioTimer[client] != INVALID_HANDLE  )
		{
			/////////////////////////////////////////////////////////////////////
			// rrGtFNg
			/////////////////////////////////////////////////////////////////////
			new team = GetClientTeam(client);
			new Float:radius = 0.8;
			new Float:pos[3];
			new Float:ang[3];
			new Float:fwd[3];
			new Float:right[3];
			
			/////////////////////////////////////////////////////////////////////
			// Aeȉꏊ
			/////////////////////////////////////////////////////////////////////
			pos = g_RadioPos[client];
			GetEntPropVector( g_PlantedRadio[client], Prop_Data, "m_angRotation", ang );	
			GetAngleVectors(ang, fwd, right, NULL_VECTOR);
			ScaleVector( fwd, 12.0 );
			pos[0] -= fwd[0];
			pos[1] -= fwd[1];
			ScaleVector( right, 5.0 );
			pos[0] -= right[0];
			pos[1] -= right[1];
			
			/////////////////////////////////////////////////////////////////////
			// ۂɃGtFNg
			/////////////////////////////////////////////////////////////////////
			pos[2] += 92.0;
			TE_SetupBeamRingPoint(pos, 0.5, MeterToUnit(radius) * 1.8, g_BeamSprite, g_HaloSprite, 0, 15, 1.0, 3.0, 0.0, g_TeamColor[team], 3, 0);
			TE_SendToAll();
			pos[2] -= 1.0;
			TE_SetupBeamRingPoint(pos, 0.5, MeterToUnit(radius) * 1.4, g_BeamSprite, g_HaloSprite, 0, 15, 1.0, 3.0, 0.0, g_TeamColor[team], 3, 0);
			TE_SendToAll();
			pos[2] -= 1.0;
			TE_SetupBeamRingPoint(pos, 0.5, MeterToUnit(radius) * 1.0, g_BeamSprite, g_HaloSprite, 0, 15, 1.0, 3.0, 0.0, g_TeamColor[team], 3, 0);
			TE_SendToAll();
			pos[2] -= 1.0;
			TE_SetupBeamRingPoint(pos, 0.5, MeterToUnit(radius) * 0.6, g_BeamSprite, g_HaloSprite, 0, 15, 1.0, 3.0, 0.0, g_TeamColor[team], 3, 0);
			TE_SendToAll();
			if( team == _:TFTeam_Red)
			{
				SpawnParticle( EFFECT_LIGHT_RED, 0.5, _, _, _, pos, _, _ );
			}
			else
			{
				SpawnParticle( EFFECT_LIGHT_BLU, 0.5, _, _, _, pos, _, _ );
			}	
			
			
		}else
		{
			/////////////////////////////////////////////////////////////////////
			// TEh~
			/////////////////////////////////////////////////////////////////////
			if( g_NowMusic[client] > -1 )
			{
				StopSound(g_PlantedRadio[client], 0, SOUND_MUSIC[g_NowMusic[client]]);
				g_NowMusic[client] = -1;
			}
		}
	}
}