/////////////////////////////////////////////////////////////////////
// Changelog
/////////////////////////////////////////////////////////////////////
// 2013.01.27
// 2013.05.04 - SetEntProp(sapper, Prop_Data, "m_nSolidType", 6);  SetEntProp(sapper, Prop_Send, "m_nSolidType", 6);
// 2014.01.01 - Festive SapperThe Ap-Sapłgp\ɂB

/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Sapper Throw"
#define PL_DESC "SapperThrow"
#define PL_VERSION "2014.01.01"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}

/////////////////////////////////////////////////////////////////////
//
// fTEh
//
/////////////////////////////////////////////////////////////////////
#define MDL_THROW_SAPPER "models/weapons/c_models/c_sapper/c_sapper.mdl"
#define MDL_THROW_SAPPER2 "models/weapons/c_models/c_sapper/c_sapper_xmas.mdl"
#define MDL_THROW_SAPPER3 "models/weapons/c_models/c_p2rec/c_p2rec.mdl"

#define SOUND_SAPPER_REMOVED "weapons/sapper_removed.wav"
#define SOUND_SAPPER_NOISE "weapons/sapper_timer.wav"
#define SOUND_SAPPER_NOISE2 "player/invulnerable_off.wav"
#define SOUND_SAPPER_PLANT "weapons/sapper_plant.wav"
#define SOUND_SAPPER_THROW "weapons/knife_swing.wav"
#define SOUND_RECHARGED "player/recharged.wav"
#define SOUND_BOOT "weapons/weapon_crit_charged_on.wav"
#define SOUND_NO_THROW "weapons/medigun_no_target.wav"
#define SPRITE_ELECTRIC_WAVE "sprites/laser.vmt"
#define EFFECT_CORE_FLASH "sapper_coreflash"
#define EFFECT_DEBRIS "sapper_debris"
#define EFFECT_FLASH "sapper_flash"
#define EFFECT_FLASHUP "sapper_flashup"
#define EFFECT_FLYINGEMBERS "sapper_flyingembers"
#define EFFECT_SMOKE "sapper_smoke"
#define EFFECT_SENTRY_FX "sapper_sentry1_fx"
#define EFFECT_SENTRY_SPARKS1 "sapper_sentry1_sparks1"
#define EFFECT_SENTRY_SPARKS2 "sapper_sentry1_sparks2"
#define EFFECT_TRAIL_RED "stunballtrail_red_crit"
#define EFFECT_TRAIL_BLU "stunballtrail_blue_crit"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define MAX_TARGET_BUILDING 10			// xɒ~錚

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new Handle:g_EffectiveRadius = INVALID_HANDLE;					// ConVarL͈
new Handle:g_EffectiveTime = INVALID_HANDLE;					// ConVarL
new Handle:g_RechargeTime = INVALID_HANDLE;						// ConVar`[W

new g_EffectSprite;												// GtFNgpXvCg

new g_ThrowSapper[MAXPLAYERS+1] = -1;							// Tbp[
new Float:g_SapperPos[MAXPLAYERS+1][3];							// Tbp[̈ʒu
new g_TargetBuilding[MAXPLAYERS+1][MAX_TARGET_BUILDING];		// ^[QbgrfBO

new Handle:g_RemoveSapperTimer[MAXPLAYERS+1] = INVALID_HANDLE;	// Tbp[Ń^C}[
new Handle:g_SapperLoopTimer[MAXPLAYERS+1] = INVALID_HANDLE;	// GtFNgp̃^C}[
new Handle:g_RechargeTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// `[W^C}[

new Float:g_NextUseTime[MAXPLAYERS+1] = 0.0; 					// Ɏg悤ɂȂ܂ł̎

new g_TeamColor[4][4];									// `[J[



/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );
	
	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_EffectiveRadius,		"effective_radius",		"2.5",	"Effective radius[meter]",		0, "0.0",	"100.0",	FMT_Float);
	AddCVar( g_EffectiveTime,		"effective_time",		"3.0",	"Effective time",				0, "0.0",	"120.0",	FMT_Float);
	AddCVar( g_RechargeTime,		"recharge_time",		"12.0",	"Recharge time",				0, "0.0",	"120.0",	FMT_Float);

	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S

	/////////////////////////////////////////////////////////////////////
	// `[J[ݒ
	/////////////////////////////////////////////////////////////////////
	g_TeamColor[_:TFTeam_Red][0] = 255;
	g_TeamColor[_:TFTeam_Red][1] = 32;
	g_TeamColor[_:TFTeam_Red][2] = 32;
	g_TeamColor[_:TFTeam_Red][3] = 128;
	g_TeamColor[_:TFTeam_Blue][0] = 32;
	g_TeamColor[_:TFTeam_Blue][1] = 32;
	g_TeamColor[_:TFTeam_Blue][2] = 255;
	g_TeamColor[_:TFTeam_Blue][3] = 128;
}

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Spy );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "TF_WEAPON_BUILDER_SPY", "0" );
	AddReqItems( "The Ap-Sap", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// Tbp[
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		RemoveThrownSapper(i);
	}

	/////////////////////////////////////////////////////////////////////
	// fTEhvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheModel(MDL_THROW_SAPPER);
	PrecacheModel(MDL_THROW_SAPPER2);
	PrecacheModel(MDL_THROW_SAPPER3);
	
	PrecacheSound(SOUND_SAPPER_REMOVED, true);
	PrecacheSound(SOUND_SAPPER_NOISE, true);
	PrecacheSound(SOUND_SAPPER_NOISE2, true);
	PrecacheSound(SOUND_SAPPER_PLANT, true);
	PrecacheSound(SOUND_SAPPER_THROW, true);
	PrecacheSound(SOUND_RECHARGED, true);
	PrecacheSound(SOUND_BOOT, true);
	PrecacheSound(SOUND_NO_THROW, true);
	
	g_EffectSprite = PrecacheModel(SPRITE_ELECTRIC_WAVE, true);
}


/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// L[Ԃۑ
	/////////////////////////////////////////////////////////////////////
	SaveKeyTime(client);
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// ^C}[NA
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_RemoveSapperTimer[client]);
	ClearTimer(g_SapperLoopTimer[client]);
	ClearTimer(g_RechargeTimer[client]);
	
	/////////////////////////////////////////////////////////////////////
	// Tbp[폜
	/////////////////////////////////////////////////////////////////////
	RemoveThrownSapper(client);
	
	/////////////////////////////////////////////////////////////////////
	// Ɏg܂ł̎ԃZbg
	/////////////////////////////////////////////////////////////////////
	g_NextUseTime[client] = 0.0;


	return Plugin_Continue;
}


/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// AreB
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{			
				/////////////////////////////////////////////////////////////////////
				// `FbN
				/////////////////////////////////////////////////////////////////////
				// L[`FbN
				if( CheckElapsedTime(client, 0.5) )
				{
					/////////////////////////////////////////////////////////////////////
					// XyVA^bN
					/////////////////////////////////////////////////////////////////////
					if ( GetClientButtons(client) & IN_ATTACK3 )
					{
						/////////////////////////////////////////////////////////////////////
						// `FbN
						/////////////////////////////////////////////////////////////////////
						if(TF2_CurrentWeaponEqual(client, "CTFWeaponBuilder") || TF2_CurrentWeaponEqual(client, "CTFWeaponSapper"))
						{
							/////////////////////////////////////////////////////////////////////
							// L[Ԃۑ
							/////////////////////////////////////////////////////////////////////
							SaveKeyTime(client);
							
							/////////////////////////////////////////////////////////////////////
							// ȂƂfbhK[ȂƂ
							/////////////////////////////////////////////////////////////////////
							if(!TF2_IsPlayerCloaked(client) && !TF2_IsPlayerChangingCloak(client) && !TF2_IsReadyFeignDeath(client))
							{
								/////////////////////////////////////////////////////////////////////
								// `[WĂ
								/////////////////////////////////////////////////////////////////////
								if( g_NextUseTime[client] <= GetGameTime() )
								{
									// Tbp[
									ThrowSapper(client);
									return;
								}
								/////////////////////////////////////////////////////////////////////
								// ĂȂƂ̓bZ[W
								/////////////////////////////////////////////////////////////////////
								else
								{
									PrintToChat(client, "\x05%T", "MESSAGE_NO_CHARGE", client, g_NextUseTime[client] - GetGameTime());
								}
							}
						}
						/////////////////////////////////////////////////////////////////////
						// Ȃ
						/////////////////////////////////////////////////////////////////////
						EmitSoundToClient(client, SOUND_NO_THROW, client, _, _, _, 1.0);
					}
				}				
				
				/////////////////////////////////////////////////////////////////////
				// Tbp[`FbN
				/////////////////////////////////////////////////////////////////////
				SapperActivateCheck(client);

			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// Tbp[`FbN
//
/////////////////////////////////////////////////////////////////////
stock SapperActivateCheck(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Tbp[`FbN
	/////////////////////////////////////////////////////////////////////
	if(g_ThrowSapper[client] != -1)
	{
		/////////////////////////////////////////////////////////////////////
		// Tbp[
		/////////////////////////////////////////////////////////////////////
		if(IsValidEntity(g_ThrowSapper[client]))
		{	
			/////////////////////////////////////////////////////////////////////
			// ړ
			/////////////////////////////////////////////////////////////////////
			if(GetEntityMoveType(g_ThrowSapper[client]) != MOVETYPE_NONE)
			{
				/////////////////////////////////////////////////////////////////////
				// Tbp[̈ʒu
				/////////////////////////////////////////////////////////////////////
				new Float:SapperDiff[3];
				new Float:SapperPos[3];
				GetEntPropVector(g_ThrowSapper[client], Prop_Data, "m_vecAbsOrigin", SapperPos);
				
				/////////////////////////////////////////////////////////////////////
				// OʒuƔr
				/////////////////////////////////////////////////////////////////////
				SapperDiff[0] = g_SapperPos[client][0] - SapperPos[0];
				SapperDiff[1] = g_SapperPos[client][1] - SapperPos[1];
				SapperDiff[2] = g_SapperPos[client][2] - SapperPos[2];
				
				/////////////////////////////////////////////////////////////////////
				// ~܂甭
				/////////////////////////////////////////////////////////////////////
				if( FloatAbs(SapperDiff[0]) < 0.1 && FloatAbs(SapperDiff[1]) < 0.1 && FloatAbs(SapperDiff[2]) < 0.1 )
				{
					/////////////////////////////////////////////////////////////////////
					// ړȂ
					/////////////////////////////////////////////////////////////////////
					SetEntityMoveType(g_ThrowSapper[client], MOVETYPE_NONE);				// ړ^Cv
					
					/////////////////////////////////////////////////////////////////////
					// ɑ̐l̃Tbp[Δj󂷂
					/////////////////////////////////////////////////////////////////////
					for(new i = 0; i < MAXPLAYERS + 1; i++)
					{
						if(client != i)
						{
//							if(CanSeeTarget(g_ThrowSapper[client], g_SapperPos[client], g_ThrowSapper[i], g_SapperPos[i], GetConVarFloat(g_EffectiveRadius)))

							/////////////////////////////////////////////////////////////////////
							// w苗ȓH
							/////////////////////////////////////////////////////////////////////
							if( GetVectorDistanceMeter(g_SapperPos[client], g_SapperPos[i]) < GetConVarFloat(g_EffectiveRadius) )
							{			
								/////////////////////////////////////////////////////////////////////
								// Tbp[H
								/////////////////////////////////////////////////////////////////////
								new hitEnt = -1;
								HitCheck( g_SapperPos[i], NULL_VECTOR, g_SapperPos[client], MASK_SHOT, hitEnt, SapperTraceFilter, 0 );
								if( hitEnt == g_ThrowSapper[client] )
								{								
									RemoveThrownSapper(i);
								}
							}
						}
					}
					
					/////////////////////////////////////////////////////////////////////
					// ~߂
					/////////////////////////////////////////////////////////////////////
					StopSound(g_ThrowSapper[client], 0, SOUND_BOOT);			

					/////////////////////////////////////////////////////////////////////
					// TEh
					/////////////////////////////////////////////////////////////////////
					EmitSoundToAll(SOUND_SAPPER_NOISE, g_ThrowSapper[client], _, _, SND_CHANGEPITCH, 1.0, 150);	
					EmitSoundToAll(SOUND_SAPPER_NOISE2, g_ThrowSapper[client], _, _, SND_CHANGEPITCH, 1.0, 60);
					EmitSoundToAll(SOUND_SAPPER_PLANT, g_ThrowSapper[client], _, _, _, 1.0);
					
					/////////////////////////////////////////////////////////////////////
					// Ń^C}[ݒ
					/////////////////////////////////////////////////////////////////////
					ClearTimer(g_RemoveSapperTimer[client]);	
					g_RemoveSapperTimer[client] = CreateTimer(GetConVarFloat(g_EffectiveTime), Timer_RemoveSapper, client);
//					g_RemoveSapperTimer[client] = CreateTimer(3.0, Timer_RemoveSapper, client);
					
					
					/////////////////////////////////////////////////////////////////////
					// [v^C}[ݒ
					/////////////////////////////////////////////////////////////////////
					ClearTimer(g_SapperLoopTimer[client]);
					g_SapperLoopTimer[client] = CreateTimer(0.5, Timer_SapperLoop, client, TIMER_REPEAT);
					Timer_SapperLoop(g_SapperLoopTimer[client], client);	// Ƃ肠񔭓
			
				}
				
				/////////////////////////////////////////////////////////////////////
				// Ō̈ʒuۑ
				/////////////////////////////////////////////////////////////////////
				g_SapperPos[client][0] = SapperPos[0];
				g_SapperPos[client][1] = SapperPos[1];
				g_SapperPos[client][2] = SapperPos[2];
				
			}
		}
	}	
}
/////////////////////////////////////////////////////////////////////
//
// g[XtB^
//
/////////////////////////////////////////////////////////////////////
public bool:SapperTraceFilter( entity, contentsMask, any:data )
{
	new String:entName[64];
	GetEntityClassname(entity, entName, sizeof(entName));
//	PrintToServer("entity = %d %s", entity, entName);
	
	/////////////////////////////////////////////////////////////////////
	// vC[ȊO
	// ȊO
	// `FbN
	/////////////////////////////////////////////////////////////////////
	return entity > MAXPLAYERS && !StrEqual( entName, "obj_dispenser")
	&& !StrEqual( entName, "obj_sentrygun")
	&& !StrEqual( entName, "obj_teleporter");
}


/////////////////////////////////////////////////////////////////////
//
// [v^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_SapperLoop(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Tbp[`FbN
	/////////////////////////////////////////////////////////////////////
	if(g_ThrowSapper[client] != -1 && IsClientInGame( client ))
	{
		/////////////////////////////////////////////////////////////////////
		// GeBeB
		/////////////////////////////////////////////////////////////////////
		if(IsValidEntity(g_ThrowSapper[client]))
		{	
			/////////////////////////////////////////////////////////////////////
			// Tbp[̈ʒu
			/////////////////////////////////////////////////////////////////////
			GetEntPropVector(g_ThrowSapper[client], Prop_Data, "m_vecAbsOrigin", g_SapperPos[client]);

			/////////////////////////////////////////////////////////////////////
			// rrGtFNg
			/////////////////////////////////////////////////////////////////////
			new team = GetClientTeam(client);
			new Float:radius = GetConVarFloat(g_EffectiveRadius);
			TE_SetupBeamRingPoint(g_SapperPos[client], 0.1, MeterToUnit(radius) * 1.8, g_EffectSprite, g_EffectSprite, 1, 1, 0.6, 3.0, 40.0, g_TeamColor[team], 15, 0);
			TE_SendToAll();
			TE_SetupBeamRingPoint(g_SapperPos[client], 0.1, MeterToUnit(radius) * 1.4, g_EffectSprite, g_EffectSprite, 1, 1, 0.6, 3.0, 40.0, g_TeamColor[team], 15, 0);
			TE_SendToAll();
			TE_SetupBeamRingPoint(g_SapperPos[client], 0.1, MeterToUnit(radius) * 1.0, g_EffectSprite, g_EffectSprite, 1, 1, 0.6, 3.0, 40.0, g_TeamColor[team], 15, 0);
			TE_SendToAll();
			TE_SetupBeamRingPoint(g_SapperPos[client], 0.1, MeterToUnit(radius) * 0.6, g_EffectSprite, g_EffectSprite, 1, 1, 0.6, 3.0, 40.0, g_TeamColor[team], 15, 0);
			TE_SendToAll();
			
			/////////////////////////////////////////////////////////////////////
			// ͂̃XpC̕ϑ N[NQ[W
			/////////////////////////////////////////////////////////////////////
			new maxclients = GetMaxClients();
			for (new victim = 1; victim <= maxclients; victim++)
			{
				/////////////////////////////////////////////////////////////////////
				// Q[ɓĂ
				/////////////////////////////////////////////////////////////////////
				if( IsClientInGame( victim ) && IsPlayerAlive( victim ) )
				{
					/////////////////////////////////////////////////////////////////////
					// XpĈ
					/////////////////////////////////////////////////////////////////////
					if( TF2_GetPlayerClass( victim ) == TFClass_Spy )
					{
						/////////////////////////////////////////////////////////////////////
						// g[Xăqbg`FbN
						// vC[Tbp[邩H
						/////////////////////////////////////////////////////////////////////
						new Float:victimPos[3];	
						GetEntPropVector( victim, Prop_Send, "m_vecOrigin", victimPos);
						
						/////////////////////////////////////////////////////////////////////
						// w苗ȓH
						/////////////////////////////////////////////////////////////////////
						if( GetVectorDistanceMeter(g_SapperPos[client], victimPos) < radius )
						{
							/////////////////////////////////////////////////////////////////////
							// Tbp[H
							/////////////////////////////////////////////////////////////////////
							new hitEnt = -1;
							HitCheck( victimPos, NULL_VECTOR, g_SapperPos[client], MASK_SHOT, hitEnt, SapperTraceFilter, 0 );
							if( hitEnt == g_ThrowSapper[client] )
							{
								/////////////////////////////////////////////////////////////////////
								// ϑ
								/////////////////////////////////////////////////////////////////////
								if( TF2_IsPlayerDisguised( victim ) )
								{
									TF2_RemovePlayerDisguise( victim );
								}
								/////////////////////////////////////////////////////////////////////
								// N[N[^[炷
								/////////////////////////////////////////////////////////////////////
								TF2_SetPlayerCloakMeter( victim, TF2_GetPlayerCloakMeter( victim ) - 25 );
							}
						}
					}
				}
			}

			/////////////////////////////////////////////////////////////////////
			// ͂̌~
			/////////////////////////////////////////////////////////////////////
			new Float:effectPos[3];
			new targetCount = 0;
			
			/////////////////////////////////////////////////////////////////////
			// fBXyT[
			/////////////////////////////////////////////////////////////////////
			new ent = -1;
			while ((ent = FindEntityByClassname(ent, "obj_dispenser")) != -1)
			{
				/////////////////////////////////////////////////////////////////////
				// G`[̌
				/////////////////////////////////////////////////////////////////////
				new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
				if( GetClientTeam( iOwner ) != GetClientTeam( client ) )
				{
					
					/////////////////////////////////////////////////////////////////////
					// ő^[QbgĂȂ
					/////////////////////////////////////////////////////////////////////
					if(targetCount < MAX_TARGET_BUILDING)
					{
						/////////////////////////////////////////////////////////////////////
						// g[Xăqbg`FbN
						// IuWFNgTbp[邩H
						/////////////////////////////////////////////////////////////////////
						new Float:dispPos[3];
						GetEntPropVector(ent, Prop_Data, "m_vecAbsOrigin", dispPos);
						
						/////////////////////////////////////////////////////////////////////
						// w苗ȓH
						/////////////////////////////////////////////////////////////////////
						if( GetVectorDistanceMeter(g_SapperPos[client], dispPos) < radius )
						{
							/////////////////////////////////////////////////////////////////////
							// Tbp[H
							/////////////////////////////////////////////////////////////////////
							new hitEnt = -1;
							HitCheck( dispPos, NULL_VECTOR, g_SapperPos[client], MASK_SHOT, hitEnt, SapperTraceFilter, 0 );
							if( hitEnt == g_ThrowSapper[client] )
							{				
								/////////////////////////////////////////////////////////////////////
								// GtFNg
								/////////////////////////////////////////////////////////////////////
								effectPos[0] = GetRandomFloat(-25.0, 25.0);
								effectPos[1] = GetRandomFloat(-25.0, 25.0);
								effectPos[2] = GetRandomFloat(10.0, 65.0);
								SpawnParticle( EFFECT_SENTRY_FX, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS1, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS2, 0.05, _, ent, _, effectPos, _, _ );

								//SetEntProp(ent, Prop_Send, "m_bHasSapper", 1);
								/////////////////////////////////////////////////////////////////////
								// ~
								/////////////////////////////////////////////////////////////////////
								SetEntProp(ent, Prop_Send, "m_bDisabled", 1);

								/////////////////////////////////////////////////////////////////////
								// ^[QbgL^
								/////////////////////////////////////////////////////////////////////
								g_TargetBuilding[client][targetCount] = ent;
								targetCount += 1;
								
								/////////////////////////////////////////////////////////////////////
								// ݒuꂽTbp[Ƀ_[W
								/////////////////////////////////////////////////////////////////////
								DoDamagePlantedSapper(ent, 200);
							}
						}
					}
				}
			}			

			/////////////////////////////////////////////////////////////////////
			// Zg[
			/////////////////////////////////////////////////////////////////////
			ent = -1;
			while ((ent = FindEntityByClassname(ent, "obj_sentrygun")) != -1)
			{
				/////////////////////////////////////////////////////////////////////
				// G`[̌
				/////////////////////////////////////////////////////////////////////
				new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
				if( GetClientTeam( iOwner ) != GetClientTeam( client ) )
				{
					
					/////////////////////////////////////////////////////////////////////
					// ő^[QbgĂȂ
					/////////////////////////////////////////////////////////////////////
					if(targetCount < MAX_TARGET_BUILDING)
					{
						/////////////////////////////////////////////////////////////////////
						// g[Xăqbg`FbN
						// IuWFNgTbp[邩H
						/////////////////////////////////////////////////////////////////////
						new Float:sentPos[3];
						GetEntPropVector(ent, Prop_Data, "m_vecAbsOrigin", sentPos);
						
						/////////////////////////////////////////////////////////////////////
						// w苗ȓH
						/////////////////////////////////////////////////////////////////////
						if( GetVectorDistanceMeter(g_SapperPos[client], sentPos) < radius )
						{
							/////////////////////////////////////////////////////////////////////
							// Tbp[H
							/////////////////////////////////////////////////////////////////////
							new hitEnt = -1;
							HitCheck( sentPos, NULL_VECTOR, g_SapperPos[client], MASK_SHOT, hitEnt, SapperTraceFilter, 0 );
							if( hitEnt == g_ThrowSapper[client] )
							{				
								/////////////////////////////////////////////////////////////////////
								// GtFNg
								/////////////////////////////////////////////////////////////////////
								new level = GetEntProp(ent, Prop_Send, "m_iUpgradeLevel");
								effectPos[0] = GetRandomFloat(-20.0, 20.0);
								effectPos[1] = GetRandomFloat(-20.0, 20.0);
								switch(level)
								{
									case 1:
										effectPos[2] = GetRandomFloat(10.0, 55.0);
									case 2:
										effectPos[2] = GetRandomFloat(10.0, 65.0);
									case 3:
										effectPos[2] = GetRandomFloat(10.0, 75.0);
								}
								SpawnParticle( EFFECT_SENTRY_FX, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS1, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS2, 0.05, _, ent, _, effectPos, _, _ );

								//SetEntProp(ent, Prop_Send, "m_bHasSapper", 1);
								/////////////////////////////////////////////////////////////////////
								// ~
								/////////////////////////////////////////////////////////////////////
								SetEntProp(ent, Prop_Send, "m_bDisabled", 1);

								/////////////////////////////////////////////////////////////////////
								// ^[QbgL^
								/////////////////////////////////////////////////////////////////////
								g_TargetBuilding[client][targetCount] = ent;
								targetCount += 1;
								
								/////////////////////////////////////////////////////////////////////
								// ݒuꂽTbp[Ƀ_[W
								/////////////////////////////////////////////////////////////////////
								DoDamagePlantedSapper(ent, 200);
							}
						}
					}
				}
			}				

			/////////////////////////////////////////////////////////////////////
			// e|[^[
			/////////////////////////////////////////////////////////////////////
			ent = -1;
			while ((ent = FindEntityByClassname(ent, "obj_teleporter")) != -1)
			{
				/////////////////////////////////////////////////////////////////////
				// G`[̌
				/////////////////////////////////////////////////////////////////////
				new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
				if( GetClientTeam( iOwner ) != GetClientTeam( client ) )
				{
					
					/////////////////////////////////////////////////////////////////////
					// ő^[QbgĂȂ
					/////////////////////////////////////////////////////////////////////
					if(targetCount < MAX_TARGET_BUILDING)
					{
						/////////////////////////////////////////////////////////////////////
						// g[Xăqbg`FbN
						// IuWFNgTbp[邩H
						/////////////////////////////////////////////////////////////////////
						new Float:telePos[3];
						GetEntPropVector(ent, Prop_Data, "m_vecAbsOrigin", telePos);
						
						/////////////////////////////////////////////////////////////////////
						// w苗ȓH
						/////////////////////////////////////////////////////////////////////
						if( GetVectorDistanceMeter(g_SapperPos[client], telePos) < radius )
						{
							/////////////////////////////////////////////////////////////////////
							// Tbp[H
							/////////////////////////////////////////////////////////////////////
							new hitEnt = -1;
							HitCheck( telePos, NULL_VECTOR, g_SapperPos[client], MASK_SHOT, hitEnt, SapperTraceFilter, 0 );
							if( hitEnt == g_ThrowSapper[client] )
							{				
								/////////////////////////////////////////////////////////////////////
								// GtFNg
								/////////////////////////////////////////////////////////////////////
								effectPos[0] = GetRandomFloat(-25.0, 25.0);
								effectPos[1] = GetRandomFloat(-25.0, 25.0);
								effectPos[2] = GetRandomFloat(5.0, 15.0);
								SpawnParticle( EFFECT_SENTRY_FX, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS1, 0.05, _, ent, _, effectPos, _, _ );
								SpawnParticle( EFFECT_SENTRY_SPARKS2, 0.05, _, ent, _, effectPos, _, _ );

								//SetEntProp(ent, Prop_Send, "m_bHasSapper", 1);
								/////////////////////////////////////////////////////////////////////
								// ~
								/////////////////////////////////////////////////////////////////////
								SetEntProp(ent, Prop_Send, "m_bDisabled", 1);

								/////////////////////////////////////////////////////////////////////
								// ^[QbgL^
								/////////////////////////////////////////////////////////////////////
								g_TargetBuilding[client][targetCount] = ent;
								targetCount += 1;
								
								/////////////////////////////////////////////////////////////////////
								// ݒuꂽTbp[Ƀ_[W
								/////////////////////////////////////////////////////////////////////
								DoDamagePlantedSapper(ent, 200);
							}
						}
					}
				}
			}					
			return;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// ^C}[NA
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_SapperLoopTimer[client]);	
}	

/////////////////////////////////////////////////////////////////////
//
// ꂽTbp[j
//
/////////////////////////////////////////////////////////////////////
stock DoDamagePlantedSapper(any:building, damage)
{
	/////////////////////////////////////////////////////////////////////
	// IuWFNg
	/////////////////////////////////////////////////////////////////////
	if(	TF2_EdictNameEqual(building, "obj_dispenser") ||
		TF2_EdictNameEqual(building, "obj_sentrygun") || 
		TF2_EdictNameEqual(building, "obj_teleporter")) 
	{
		/////////////////////////////////////////////////////////////////////
		// Tbp[ݒuĂ
		/////////////////////////////////////////////////////////////////////
		if(GetEntProp(building, Prop_Send, "m_bHasSapper"))
		{
			/////////////////////////////////////////////////////////////////////
			// ݒuĂTbp[
			/////////////////////////////////////////////////////////////////////
			new attachSapper = -1;
			while ((attachSapper = FindEntityByClassname(attachSapper, "obj_attachment_sapper")) != -1)
			{
				if(!GetEntProp(attachSapper, Prop_Send, "m_bPlacing"))
				{
					if(building == GetEntPropEnt(attachSapper, Prop_Send, "m_hBuiltOnEntity"))
					{
						/////////////////////////////////////////////////////////////////////
						// Tbp[Ƀ_[W
						/////////////////////////////////////////////////////////////////////
						SetVariantInt(damage);
						AcceptEntityInput(attachSapper, "RemoveHealth");
					}
				}
			}
		}	
		/////////////////////////////////////////////////////////////////////
		// Tbp[ݒuĂȂ
		/////////////////////////////////////////////////////////////////////
		else
		{
			/////////////////////////////////////////////////////////////////////
			// ݒuꂻȃTbp[
			/////////////////////////////////////////////////////////////////////
			new attachSapper = -1;
			while ((attachSapper = FindEntityByClassname(attachSapper, "obj_attachment_sapper")) != -1)
			{
				if(GetEntProp(attachSapper, Prop_Send, "m_bPlacing"))
				{
					if(building == GetEntPropEnt(attachSapper, Prop_Send, "m_hBuiltOnEntity"))
					{
						/////////////////////////////////////////////////////////////////////
						// ݒuÕTbp[͐ݒułȂ悤ɂB
						/////////////////////////////////////////////////////////////////////
						new iOwner = GetEntPropEnt(attachSapper, Prop_Send, "m_hBuilder");

						/////////////////////////////////////////////////////////////////////
						// ͂̃XpCTbp[gȂ
						/////////////////////////////////////////////////////////////////////
						new weaponIndex = GetPlayerWeaponSlot(iOwner, 1);
						if( weaponIndex != -1)
						{
							SetEntPropFloat(weaponIndex, Prop_Send, "m_flNextPrimaryAttack", GetGameTime() + 2.0);
						}
					}
				}
			}
		}
	}
	
}

/////////////////////////////////////////////////////////////////////
//
// Tbp[
//
/////////////////////////////////////////////////////////////////////
stock ThrowSapper(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Tbp[폜
	/////////////////////////////////////////////////////////////////////
	RemoveThrownSapper(client)

	/////////////////////////////////////////////////////////////////////
	// ΂p̃Tbp[쐬
	/////////////////////////////////////////////////////////////////////
	new sapper = CreateEntityByName("prop_physics_override");
	if (IsValidEntity(sapper))
	{
		SetEntPropEnt(sapper, Prop_Data, "m_hOwnerEntity", client);	// 
		switch( GetItemDefIndex( TF2_GetCurrentWeapon(client) ) )
		{
			case 735: { SetEntityModel(sapper, MDL_THROW_SAPPER);}	// ftHf
			case 736: { SetEntityModel(sapper, MDL_THROW_SAPPER);}	// ftHf
			case 1080: { SetEntityModel(sapper, MDL_THROW_SAPPER2);}	// Festive
			case 933: { SetEntityModel(sapper, MDL_THROW_SAPPER3);}	// Ap-Sap
		}
		
		
		SetEntityMoveType(sapper, MOVETYPE_VPHYSICS);				// ړ^Cv
		SetEntProp(sapper, Prop_Data, "m_CollisionGroup", 1);		// RWO[v
//		SetEntProp(sapper, Prop_Data, "m_usSolidFlags", 16);		// 蔻tO
		SetEntProp(sapper, Prop_Send, "m_nSolidType", 6);			// 蔻^Cv
		SetEntPropFloat(sapper, Prop_Data, "m_flFriction", 10000.0);	// C
		SetEntPropFloat(sapper, Prop_Data, "m_massScale", 100.0);		// d{
		DispatchSpawn(sapper);										// X|[
		new String:nameSapper[64];
		Format(nameSapper, sizeof(nameSapper), "tf2sapper%d", client);
		DispatchKeyValue(sapper, "targetname", nameSapper);
		
		new Float:pos[3];
		new Float:ang[3];
		new Float:vec[3];
		new Float:svec[3];
		new Float:pvec[3];
		GetClientEyePosition(client, pos);						// ŏ̈ʒu
		GetClientEyeAngles(client, ang);						// px
		//ang[0] -= 15.0;
		ang[1] += 2.0;
		pos[2] -= 20.0;
		GetAngleVectors(ang, vec, svec, NULL_VECTOR);	// px琳ʎ擾
		ScaleVector(vec, 500.0);								// 鑬x
		ScaleVector(svec, 30.0);								// ړxNg
		AddVectors(pos, svec, pos);
		GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", pvec);	// vC[̈ړ
		AddVectors(pvec, vec, vec);
		TeleportEntity(sapper, pos, ang, vec);					// ړ

		/////////////////////////////////////////////////////////////////////
		// ۑ
		/////////////////////////////////////////////////////////////////////
		g_ThrowSapper[client] = sapper;	
		
		/////////////////////////////////////////////////////////////////////
		// GtFNg
		/////////////////////////////////////////////////////////////////////
		if( GetClientTeam( client ) == _:TFTeam_Red )
		{
			SpawnParticle( EFFECT_TRAIL_RED, 0.0, _, sapper, _, _, _, _ ); // attach
		}
		else
		{
			SpawnParticle( EFFECT_TRAIL_BLU, 0.0, _, sapper, _, _, _, _ );
		}

		/////////////////////////////////////////////////////////////////////
		// TEh
		/////////////////////////////////////////////////////////////////////
		EmitSoundToAll(SOUND_BOOT, sapper, _, _, SND_CHANGEPITCH, 0.2, 30);	// u[g
		EmitSoundToAll(SOUND_SAPPER_THROW, client, _, _, _, 1.0);

		/////////////////////////////////////////////////////////////////////
		// OɎĂɐ؂ւ
		/////////////////////////////////////////////////////////////////////
		ClientCommand(client, "lastinv");
		
		/////////////////////////////////////////////////////////////////////
		// Ɏgp\ɂȂ܂ł̎Ԑݒ
		/////////////////////////////////////////////////////////////////////
		g_NextUseTime[client] = GetGameTime() + GetConVarFloat(g_RechargeTime);

		/////////////////////////////////////////////////////////////////////
		// `[W^C}[
		/////////////////////////////////////////////////////////////////////
		ClearTimer(g_RechargeTimer[client]);	
		g_RechargeTimer[client] = CreateTimer(GetConVarFloat(g_RechargeTime), Timer_SapperRecharge, client);
//		g_RechargeTimer[client] = CreateTimer(12.0, Timer_SapperRecharge, client);
	}
	
}
/////////////////////////////////////////////////////////////////////
//
// `[W^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_SapperRecharge(Handle:timer, any:client)
{
	g_RechargeTimer[client] = INVALID_HANDLE;
	PrintToChat(client, "\x05%T", "MESSAGE_RECHARGED_SAPPER", client);
	EmitSoundToClient(client, SOUND_RECHARGED, client, _, _, _, 1.0);
	/////////////////////////////////////////////////////////////////////
	// Ɏg鎞ԃZbg
	/////////////////////////////////////////////////////////////////////
	g_NextUseTime[client] = GetGameTime()
}

/////////////////////////////////////////////////////////////////////
//
// Tbp[Ń^C}[I
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_RemoveSapper(Handle:timer, any:client)
{
	g_RemoveSapperTimer[client] = INVALID_HANDLE;
	/////////////////////////////////////////////////////////////////////
	// Tbp[폜
	/////////////////////////////////////////////////////////////////////
	RemoveThrownSapper(client);
}

/////////////////////////////////////////////////////////////////////
//
// Tbp[폜
//
/////////////////////////////////////////////////////////////////////
stock RemoveThrownSapper(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// ^C}[NA
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_RemoveSapperTimer[client]);	
	ClearTimer(g_SapperLoopTimer[client]);	

	/////////////////////////////////////////////////////////////////////
	// Tbp[
	/////////////////////////////////////////////////////////////////////
	if(g_ThrowSapper[client] != -1)
	{
		/////////////////////////////////////////////////////////////////////
		// cĂ폜
		/////////////////////////////////////////////////////////////////////
		if(IsValidEntity(g_ThrowSapper[client]))
		{
			// ^[Qbg擾擾
			new String:nameSapper[64];
			new String:nameTarget[64];
			GetEntPropString(g_ThrowSapper[client], Prop_Data, "m_iName", nameTarget, sizeof(nameTarget));
		
			Format(nameSapper, sizeof(nameSapper), "tf2sapper%d", client);
			if(StrEqual(nameTarget, nameSapper))
			{
				new Float:SapperPos[3];
				GetEntPropVector(g_ThrowSapper[client], Prop_Data, "m_vecAbsOrigin", SapperPos);
				/////////////////////////////////////////////////////////////////////
				// GtFNg
				/////////////////////////////////////////////////////////////////////
				SpawnParticle( EFFECT_CORE_FLASH, 1.0, _, _, _, SapperPos, _, _ );
				SpawnParticle( EFFECT_DEBRIS, 1.0, _, _, _, SapperPos, _, _ );
				SpawnParticle( EFFECT_FLASH, 1.0, _, _, _, SapperPos, _, _ );
				SpawnParticle( EFFECT_FLASHUP, 1.0, _, _, _, SapperPos, _, _ );
				SpawnParticle( EFFECT_FLYINGEMBERS, 1.0, _, _, _, SapperPos, _, _ );
				SpawnParticle( EFFECT_SMOKE, 1.0, _, _, _, SapperPos, _, _ );
				
				/////////////////////////////////////////////////////////////////////
				// TEh
				/////////////////////////////////////////////////////////////////////
				StopSound(g_ThrowSapper[client], 0, SOUND_SAPPER_NOISE);	// mCY~߂
				StopSound(g_ThrowSapper[client], 0, SOUND_SAPPER_NOISE2);	// mCY~߂
				EmitSoundToAll(SOUND_SAPPER_REMOVED, g_ThrowSapper[client], _, _, _, 1.0);
	
				/////////////////////////////////////////////////////////////////////
				// ~Ă@쓮
				/////////////////////////////////////////////////////////////////////
				for(new i = 0; i < MAX_TARGET_BUILDING; i++)
				{
					if(g_TargetBuilding[client][i] != -1)
					{
						if (IsValidEntity(g_TargetBuilding[client][i]))
						{
							if(TF2_EdictNameEqual(g_TargetBuilding[client][i], "obj_dispenser")
							|| TF2_EdictNameEqual(g_TargetBuilding[client][i], "obj_sentrygun")
							|| TF2_EdictNameEqual(g_TargetBuilding[client][i], "obj_teleporter"))
							{
								//SetEntProp(g_TargetBuilding[client][i], Prop_Send, "m_bHasSapper", 0);
								SetEntProp(g_TargetBuilding[client][i], Prop_Send, "m_bDisabled", 0);
								
								/////////////////////////////////////////////////////////////////////
								// e|[^[̃`[WZbg
								/////////////////////////////////////////////////////////////////////
								if(TF2_EdictNameEqual(g_TargetBuilding[client][i], "obj_teleporter"))
								{
									SetEntProp(g_TargetBuilding[client][i], Prop_Send, "m_iState", 3);
								}
							}
							
						}
					}
				}							
				
				/////////////////////////////////////////////////////////////////////
				// ۂɍ폜
				/////////////////////////////////////////////////////////////////////
				AcceptEntityInput(g_ThrowSapper[client], "Kill");
			}
		}
	}
	/////////////////////////////////////////////////////////////////////
	// 낢돉
	/////////////////////////////////////////////////////////////////////
	g_ThrowSapper[client] = -1;
	/////////////////////////////////////////////////////////////////////
	// ߋʒu
	/////////////////////////////////////////////////////////////////////
	g_SapperPos[client][0] = 0.0;
	g_SapperPos[client][1] = 0.0;
	g_SapperPos[client][2] = 0.0;
	for(new i = 0; i < MAX_TARGET_BUILDING; i++)
	{
		g_TargetBuilding[client][i] = -1;
	}
}

