/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Stomper"
#define PL_DESC "Stomper"
#define PL_VERSION "2013.01.27"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_STOMP "mvm/mvm_money_vanish.wav"
new String:SOUND_VOICE[8][64];				// {CXt@C

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new g_StompCount[MAXPLAYERS+1] = 0;		// 񂾉
new Handle:g_JumpTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// Wv`FbN^C}[

/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S

	HookEvent( "player_hurt", 	EventPlayerHurt, 	EventHookMode_Post);	// vC[_[W
	
	
	/////////////////////////////////////////////////////////////////////
	// {CX
	/////////////////////////////////////////////////////////////////////
	SOUND_VOICE[0]	= "vo/soldier_kaboomalts02.wav"
	SOUND_VOICE[1]	= "vo/soldier_kaboomalts03.wav"
	SOUND_VOICE[2]	= "vo/soldier_laughhappy01.wav"
	SOUND_VOICE[3]	= "vo/soldier_laughhappy03.wav"
	SOUND_VOICE[4]	= "vo/soldier_jeers01.wav"
	SOUND_VOICE[5]	= "vo/soldier_laughevil02.wav"
	SOUND_VOICE[6]	= "vo/soldier_laughevil01.wav"
	SOUND_VOICE[7]	= "vo/soldier_laughshort04.wav"
	
		
}

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Soldier );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Mantreads", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEh,fvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_STOMP, true);
	for(new i = 0; i < 8; i++)
	{
		PrecacheSound(SOUND_VOICE[i], true);
	}
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	g_StompCount[client] = 0;
	ClearTimer(g_JumpTimer[client]);

	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// AreB
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{			
				/////////////////////////////////////////////////////////////////////
				// nʂvC[Ȃ疳
				/////////////////////////////////////////////////////////////////////
				new groundEntity = GetEntPropEnt( client, Prop_Data, "m_hGroundEntity" );
				if( groundEntity != -1 )
				{
					new String:className[64];
					GetEdictClassname(groundEntity, className, sizeof(className));
					if( StrEqual( className, "player") )
					{			
						continue;
					}
				}
				
				/////////////////////////////////////////////////////////////////////
				// nʂɂ瓥񂾉񐔃Zbg
				/////////////////////////////////////////////////////////////////////
				if( GetEntityFlags( client ) & FL_ONGROUND )
				{
					g_StompCount[client] = 0;
				}
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_hurt) vC[_[W
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// f[^擾
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );		// NCAgID
	new attacker = GetClientOfUserId( GetEventInt( event, "attacker" ) );	// NCAgID
	new custom = GetEventInt( event, "custom" );	// 
	
	/////////////////////////////////////////////////////////////////////
	// A^bJ[AreB
	/////////////////////////////////////////////////////////////////////
	if( client != attacker && attacker > 0 && IsSelectedAbility( attacker ) )
	{
		/////////////////////////////////////////////////////////////////////
		// Mantreadsœ񂾎
		/////////////////////////////////////////////////////////////////////
		if( custom == 45 )
		{
			/////////////////////////////////////////////////////////////////////
			// 
			/////////////////////////////////////////////////////////////////////
			Stomper( attacker, client );
		}
	}
	
}



/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
public Stomper(any:client, any:victim)
{
	/////////////////////////////////////////////////////////////////////
	// Wv^C}[
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_JumpTimer[client]);
	g_JumpTimer[client] = CreateTimer(0.2, Timer_Jump, client);
	
	/////////////////////////////////////////////////////////////////////
	// TEh炷
	/////////////////////////////////////////////////////////////////////
	EmitSoundToAll(SOUND_STOMP, victim);	

	/////////////////////////////////////////////////////////////////////
	// {CXĐ
	/////////////////////////////////////////////////////////////////////
	EmitSoundToAll(SOUND_VOICE[ GetRandomInt(0, 7) ], client);

	
	/////////////////////////////////////////////////////////////////////
	// X^
	/////////////////////////////////////////////////////////////////////
	TF2_StunPlayer(victim, 3.0+g_StompCount[client], 0.5, TF_STUNFLAG_THIRDPERSON|TF_STUNFLAG_SLOWDOWN|TF_STUNFLAG_NOSOUNDOREFFECT, client);
	
	/////////////////////////////////////////////////////////////////////
	// 񂾉񐔑₷
	/////////////////////////////////////////////////////////////////////
	g_StompCount[client]++;

}

/////////////////////////////////////////////////////////////////////
//
// Wv^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_Jump(Handle:timer, any:client)
{
	g_JumpTimer[client] = INVALID_HANDLE;
}

/////////////////////////////////////////////////////////////////////
//
// vC[R}h
//
/////////////////////////////////////////////////////////////////////
public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	/////////////////////////////////////////////////////////////////////
	// Wv
	/////////////////////////////////////////////////////////////////////
	if (buttons & IN_JUMP)
	{
		/////////////////////////////////////////////////////////////////////
		// AreBŃWv^C}[
		/////////////////////////////////////////////////////////////////////
		if( IsSelectedAbility( client ) && g_JumpTimer[client] != INVALID_HANDLE )
		{
			/////////////////////////////////////////////////////////////////////
			// Wv
			/////////////////////////////////////////////////////////////////////
			new Float:fVelocity[3];
			GetEntPropVector( client, Prop_Data, "m_vecAbsVelocity", fVelocity );
			fVelocity[2] = 800.0;
			SetEntPropVector( client, Prop_Data, "m_vecAbsVelocity", fVelocity );			
			
			/////////////////////////////////////////////////////////////////////
			// h̓Abv
			/////////////////////////////////////////////////////////////////////
			TF2_AddCondition(client, TFCond_DefenseBuffed, 2.0);
			
			/////////////////////////////////////////////////////////////////////
			// ^C}[NA
			/////////////////////////////////////////////////////////////////////
			ClearTimer(g_JumpTimer[client]);
		}
	}
}
