/////////////////////////////////////////////////////////////////////
// Changelog
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
//
// CVar֘A
//
/////////////////////////////////////////////////////////////////////
#if defined _rmf_tf2cvar_included
#endinput
#endif
#define _rmf_tf2cvar_included

/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define MAX_CVAR_NUM		24	// CVarő吔
#define MAX_CVAR_STR_LEN	64	// CVarő啶
// vOC
#define MAX_PLUGIN_NAME		64			// vOCő啶
#define MAX_PLUGIN_VERSION	16			// vOCo[W

/////////////////////////////////////////////////////////////////////
//
// 񋓌^
//
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
// CVar^
/////////////////////////////////////////////////////////////////////
enum FormatType
{
	FMT_Bool,
	FMT_Int,
	FMT_Float,
	FMT_String
};

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
// vOC
new String:g_PluginNameShort[MAX_PLUGIN_NAME];					// vOC(t@C)
new String:g_PluginNameLong[MAX_PLUGIN_NAME];					// vOC
new String:g_PluginVersion[MAX_PLUGIN_VERSION]	= "0000.00.00";	// vOCo[W
// conVars
new g_cvarCount = 0;											// o^ĂCvar
new Handle:g_cvarHandle[MAX_CVAR_NUM];							// nh
new String:g_cvarName[MAX_CVAR_NUM][MAX_CVAR_STR_LEN];			// O
new String:g_cvarDefault[MAX_CVAR_NUM][MAX_CVAR_STR_LEN];		// ftHgl
new String:g_cvarDesc[MAX_CVAR_NUM][MAX_CVAR_STR_LEN];			// Tv
new String:g_cvarMinValuve[MAX_CVAR_NUM][MAX_CVAR_STR_LEN];		// ŏl
new String:g_cvarMaxValuve[MAX_CVAR_NUM][MAX_CVAR_STR_LEN];		// ől
new FormatType:g_cvarFormat[MAX_CVAR_NUM];						// tH[}bg
// nh
new Handle:g_cvarFunction;										// `֐nh

//new Handle:g_CVarInfo		= INVALID_HANDLE;					// CVarp
new Handle:g_CVarPluginOn	= INVALID_HANDLE;					// 삵ĂHnh


/////////////////////////////////////////////////////////////////////
//
// CVAR
//
/////////////////////////////////////////////////////////////////////
public CVarInit( const String:_name[],  const String:_version[] )
{
	/////////////////////////////////////////////////////////////////////
	// ֐`
	/////////////////////////////////////////////////////////////////////
	g_cvarFunction = Handle:CreateGlobalForward( "OnConVarChanged", ET_Event, Param_Any, Param_String, Param_String );
	
	/////////////////////////////////////////////////////////////////////
	// vOCƃo[Wݒ
	/////////////////////////////////////////////////////////////////////
	strcopy(g_PluginNameLong, MAX_PLUGIN_NAME, _name);
	GetPluginFilename( INVALID_HANDLE, g_PluginNameShort, sizeof( g_PluginNameShort ) );
	ReplaceString( g_PluginNameShort, sizeof( g_PluginNameShort ), ".smx", "" );
	strcopy(g_PluginVersion, MAX_PLUGIN_VERSION, _version);
	
	/////////////////////////////////////////////////////////////////////
	// Info쐬
	/////////////////////////////////////////////////////////////////////
	new String:name[256];
	Format( name, sizeof( name ), "sm_tf_%s", g_PluginNameShort);
	CreateConVar(name, g_PluginVersion, g_PluginNameLong, FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	/////////////////////////////////////////////////////////////////////
	// ConVar쐬
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarPluginOn, "allowed", "1", "Disable/Enable", 0, "0", "1", FMT_Bool);

	/////////////////////////////////////////////////////////////////////
	// R}h\p̃R}h
	/////////////////////////////////////////////////////////////////////
	Format( name, sizeof( name ), "sm_rmf_%s", g_PluginNameShort );
	RegServerCmd( name, ListConVar );	
}

/////////////////////////////////////////////////////////////////////
//
// CVARo^
//
/////////////////////////////////////////////////////////////////////
stock Handle:AddCVar( &Handle:cvarHandle, const String:name[], const String:defaultValue[], const String:description[]="", flags=0, const String:minValue[] = "", const String:maxValue[] = "", FormatType:format = FMT_String)
{

	/////////////////////////////////////////////////////////////////////
	// vOCCVar
	/////////////////////////////////////////////////////////////////////
	new String:buff[256];
	Format( buff, sizeof( buff ), "sm_rmf_%s_%s", g_PluginNameShort, name);
	
	/////////////////////////////////////////////////////////////////////
	// ۂɓo^
	/////////////////////////////////////////////////////////////////////
	cvarHandle = CreateConVar( buff, defaultValue, description, flags );
	
	/////////////////////////////////////////////////////////////////////
	// f[^ۑ
	/////////////////////////////////////////////////////////////////////
	if( cvarHandle != INVALID_HANDLE )
	{
		if( g_cvarCount < MAX_CVAR_NUM )
		{
			g_cvarHandle[g_cvarCount] = cvarHandle;
			strcopy( g_cvarName[g_cvarCount],		MAX_CVAR_STR_LEN, name);
			strcopy( g_cvarDefault[g_cvarCount],	MAX_CVAR_STR_LEN, defaultValue);
			strcopy( g_cvarDesc[g_cvarCount],		MAX_CVAR_STR_LEN, description);
			strcopy( g_cvarMinValuve[g_cvarCount],	MAX_CVAR_STR_LEN, minValue);
			strcopy( g_cvarMaxValuve[g_cvarCount],	MAX_CVAR_STR_LEN, maxValue);
			g_cvarFormat[g_cvarCount] = format;
			
			/////////////////////////////////////////////////////////////////////
			// őlƍŏl̂tbN@Booll
			/////////////////////////////////////////////////////////////////////
			if( !StrEqual( minValue, maxValue ) || g_cvarFormat[g_cvarCount] == FMT_Bool)
			{
				HookConVarChange( cvarHandle,	ConVarChange );	
			}
			
			/////////////////////////////////////////////////////////////////////
			// CVARJEgUP
			/////////////////////////////////////////////////////////////////////
			g_cvarCount++;
		}
	}
	
}

/////////////////////////////////////////////////////////////////////
//
// ConVarύX
//
/////////////////////////////////////////////////////////////////////
public ConVarChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	for(new i = 0; i < MAX_CVAR_NUM; i++ )
	{
		if( convar == g_cvarHandle[i] )
		{
			if( g_cvarFormat[i] == FMT_Bool )
			{
				if ( StringToInt(newValue) != 0 && StringToInt(newValue) != 1 )
				{
					SetConVarInt(convar, StringToInt(oldValue), false, false);
					PrintToServer( "Warning: Value has to be 0 or 1" );
				}
			}
			else if( g_cvarFormat[i] == FMT_Int )
			{
				if (StringToInt(newValue) < StringToInt(g_cvarMinValuve[i]) || StringToInt(newValue) > StringToInt(g_cvarMaxValuve[i]))
				{
					SetConVarInt(convar, StringToInt(oldValue), false, false);
					PrintToServer( "Warning: Value has to be between %s and %s", g_cvarMinValuve[i], g_cvarMaxValuve[i] );
				}			
			}
			else if( g_cvarFormat[i] == FMT_Float )
			{
				if ( StringToFloat(newValue) < StringToFloat(g_cvarMinValuve[i]) || StringToFloat(newValue) > StringToFloat(g_cvarMaxValuve[i]) )
				{
					SetConVarFloat(convar, StringToFloat(oldValue), false, false);
					PrintToServer( "Warning: Value has to be between %s and %s", g_cvarMinValuve[i], g_cvarMaxValuve[i] );
				}
			}
			break;
		}
	}

	/////////////////////////////////////////////////////////////////////
	// ֐Ăяo
	/////////////////////////////////////////////////////////////////////
	Call_StartForward( g_cvarFunction );
	Call_PushCell( convar );
	Call_PushString( oldValue );
	Call_PushString( newValue );
	Call_Finish();
}

/////////////////////////////////////////////////////////////////////
//
// O`
//
/////////////////////////////////////////////////////////////////////
//forward public OnConVarChanged( Handle:convar, const String:oldValue[], const String:newValue[] );

/////////////////////////////////////////////////////////////////////
//
// R}h\p̃R}h
//
/////////////////////////////////////////////////////////////////////
public Action:ListConVar(args)
{
	/////////////////////////////////////////////////////////////////////
	// ConVar̕\
	/////////////////////////////////////////////////////////////////////
	PrintToServer( "====== %s Command List - version: %s ======", g_PluginNameLong, g_PluginVersion );
	new String:carLine[256];
//	Format( name, sizeof( name ), "sm_rmf_allow_%s - Disable/Enable (0 = Disable | 1 = Enable) - Default:1", g_PluginNameShort);
//	PrintToServer( name );
	
	for(new i = 0; i < g_cvarCount; i++ )
	{
		new String:nowValuve[256];
		new String:valueBetween[256] = "";
		/////////////////////////////////////////////////////////////////////
		// ݒl̎擾
		/////////////////////////////////////////////////////////////////////
		if( g_cvarFormat[i] == FMT_Bool )
		{
			IntToString( _:GetConVarBool( g_cvarHandle[ i ] ), nowValuve, sizeof( nowValuve ) );
			Format( valueBetween, sizeof( valueBetween ), "0=Disable|1=Enable");
		}
		else if( g_cvarFormat[i] == FMT_Int )
		{
			IntToString( GetConVarInt( g_cvarHandle[ i ] ), nowValuve, sizeof( nowValuve ) );
			Format( valueBetween, sizeof( valueBetween ), "%s-%s", g_cvarMinValuve[ i ], g_cvarMaxValuve[ i ]);
		}
		else if( g_cvarFormat[i] == FMT_Float )
		{
			FloatToString( GetConVarFloat( g_cvarHandle[ i ] ), nowValuve, sizeof( nowValuve ) );
			Format( valueBetween, sizeof( valueBetween ), "%s-%s", g_cvarMinValuve[ i ], g_cvarMaxValuve[ i ]);
		}
		else if( g_cvarFormat[i] == FMT_String )
		{
			GetConVarString( g_cvarHandle[ i ], nowValuve, sizeof( nowValuve ) );
		}

		if( StrEqual( valueBetween, ""  ) )
		{
			Format( carLine, sizeof( carLine ), "sm_rmf_%s_%s - %s - Default:%s - Now:%s", g_PluginNameShort, g_cvarName[i], g_cvarDesc[i], g_cvarDefault[i], nowValuve );
		}
		else
		{
			Format( carLine, sizeof( carLine ), "sm_rmf_%s_%s - %s (%s) - Default:%s - Now:%s", g_PluginNameShort, g_cvarName[i], g_cvarDesc[i], valueBetween, g_cvarDefault[i], nowValuve );
		}
		PrintToServer( carLine );
	}
	PrintToServer( "========================================================" );
	
}

/////////////////////////////////////////////////////////////////////
// vOC쒆H
/////////////////////////////////////////////////////////////////////
stock bool:IsRunning()
{
	if( g_CVarPluginOn != INVALID_HANDLE )
	{
		return GetConVarBool( g_CVarPluginOn );
	}
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// Agr[gṕeLXg擾
//
/////////////////////////////////////////////////////////////////////
stock GetPercentageString( Float:magnification, String:str[], maxlength )
{
	// p[Ze[W擾
	new percentage = RoundFloat( magnification * 100.0 - 100.0 );
	new String:value[16];
	
	// XgOɕϊ
	IntToString( percentage, value, sizeof( value ) );
	
	if( magnification > 1.0 )
	{
		new String:plus[16];
		plus = "+";
		StrCat( plus, sizeof( plus ), value );
		strcopy( str, maxlength, plus);
	}
	else
	{
		strcopy( str, maxlength, value);
	}
}
