/////////////////////////////////////////////////////////////////////
//
// TF2pvC[֐Q
//
/////////////////////////////////////////////////////////////////////
#if defined _rmf_tf2player_included
#endinput
#endif
#define _rmf_tf2player_included

/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// H
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerCloaked(client)
{
    return TF2_IsPlayerInCondition(client, TFCond_Cloaked);
}

/////////////////////////////////////////////////////////////////////
//
// ϑH
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerDisguised(client)
{
    return TF2_IsPlayerInCondition(client, TFCond_Disguised);
}

/////////////////////////////////////////////////////////////////////
//
// EڍsH
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerChangingCloak(client)
{
	if( TF2_GetPlayerClass(client) == TFClass_Spy )
	{
		if(GetGameTime() <= GetEntPropFloat(client, Prop_Send, "m_flInvisChangeCompleteTime"))
		{
			return true;
		}
	}
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// USH
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerFeignDeath(client)
{
    return TF2_IsPlayerInCondition(client, TFCond_DeadRingered);
}

/////////////////////////////////////////////////////////////////////
//
// DeadRinger
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsReadyFeignDeath(client)
{
	if( TF2_GetPlayerClass(client) == TFClass_Spy )
	{
	    return bool:GetEntProp(client, Prop_Send, "m_bFeignDeathReady");
	}
	
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// [o[H
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerChargeReleased(client)
{
	new index = GetPlayerWeaponSlot(client, 1);
	if (index > 0)
	{
		new String:classname[64];
		TF2_GetEntityClass(index, classname, sizeof(classname));
		
		if( StrEqual(classname, "CWeaponMedigun") )
		{
			return bool:GetEntProp(index, Prop_Send, "m_bChargeRelease");
		}
	}		
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// GA_bV
//
/////////////////////////////////////////////////////////////////////
stock bool:TF2_IsPlayerAirDash(client)
{
	if( GetEntProp( client, Prop_Send, "m_iAirDash" ) > 0 )
	{
		return true;
	}
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// GA_bV
//
/////////////////////////////////////////////////////////////////////
stock _:TF2_AirDashNum(client)
{
	return GetEntProp( client, Prop_Send, "m_iAirDash" );

}

////////////////////////////////////////
//
// q[Ώێ擾
//
////////////////////////////////////////
stock _:TF2_GetHealingTarget(client)
{
	new String:classname[64];
	TF2_GetCurrentWeaponClass(client, classname, sizeof(classname));
	
	if( StrEqual(classname, "CWeaponMedigun") )
	{
		new index = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		if( GetEntProp(index, Prop_Send, "m_bHealing") == 1 )
		{
			return GetEntPropEnt(index, Prop_Send, "m_hHealingTarget");
		}
	}
		
	return -1;
}
////////////////////////////////////////
//
// ݂̕
//
////////////////////////////////////////
stock TF2_GetCurrentWeapon(any:client)
{
	if( client > 0 )
	{
		// `FbN
		new weaponIndex = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		return weaponIndex;
	}
	return -1;
}
/////////////////////////////////////////////////////////////////////
//
// NX擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetCurrentWeaponClass(client, String:name[], maxlength)
{
	if( client > 0 )
	{
		new index = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		if (index > 0)
			GetEntityNetClass(index, name, maxlength);
	}
}

////////////////////////////////////////
//
// ݂̕`FbN
//
////////////////////////////////////////
stock bool:TF2_CurrentWeaponEqual(client, String:name[])
{
	if( client > 0 )
	{
		// 햼擾
		new String:classname[64];
		TF2_GetCurrentWeaponClass(client, classname, 64);
		return StrEqual(classname, name);
	}
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// vC[̑x擾
//
/////////////////////////////////////////////////////////////////////
stock Float:TF2_GetPlayerSpeed(client)
{
	if( client > 0 )
	{
		new Float:vec[3];
		GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", vec);
		return GetVectorLength(vec);
	}
	return 0.0;
}

/////////////////////////////////////////////////////////////////////
//
// ^[QbgvC[ǂ`FbN
//
/////////////////////////////////////////////////////////////////////
stock bool:IsPlayer( client )
{
	if( client > 0 )
	{
		new String:classname[64];
		TF2_GetEntityClass( client, classname, sizeof(classname) );
		
		if( StrEqual(classname, "CTFPlayer") )
		{
			return true;
		}
	}
	
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// vC[̃ftHgwX擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerDefaultHealth(client)
{
	if( client > 0 )
	{
	    return GetEntProp(client, Prop_Data, "m_iMaxHealth");
	}  
	return 100;
}

/////////////////////////////////////////////////////////////////////
//
// q[[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetNumHealers(client)
{
    return GetEntProp(client, Prop_Send, "m_nNumHealers");
}

			
////////////////////////////////////////
//
// [o[ʎ擾
//
////////////////////////////////////////
stock TF2_GetPlayerUberLevel(client)
{
	new index = GetPlayerWeaponSlot(client, 1);
					
	if (index > 0)
	{
		new String:classname[64];
		TF2_GetWeaponClass(index, classname, sizeof(classname));
		
		if( StrEqual(classname, "CWeaponMedigun") )
		{
			return RoundFloat(GetEntPropFloat(index, Prop_Send, "m_flChargeLevel")*100);
		}
		
	}
	return 0;
}
////////////////////////////////////////
//
// [o[ʐݒ
//
////////////////////////////////////////
stock TF2_SetPlayerUberLevel(client, uberlevel)
{
	if( uberlevel > 100 )
	{
		uberlevel = 100;
	}
	
	new index = GetPlayerWeaponSlot(client, 1);
	if (index > 0)
	{
		new String:classname[64];
		TF2_GetWeaponClass(index, classname, sizeof(classname));
		
		if( StrEqual(classname, "CWeaponMedigun") )
		{
			SetEntPropFloat(index, Prop_Send, "m_flChargeLevel", uberlevel*0.01);
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// N[N[^[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerCloakMeter(client)
{
    return RoundFloat(GetEntPropFloat(client, Prop_Send, "m_flCloakMeter"));
}

/////////////////////////////////////////////////////////////////////
//
// N[N[^[ݒ
//
/////////////////////////////////////////////////////////////////////
stock TF2_SetPlayerCloakMeter(client, cloakMeter)
{
	if( cloakMeter < 0 )
	{
		cloakMeter = 0;
	}
	if( cloakMeter > 100 )
	{
		cloakMeter = 100;
	}
	SetEntPropFloat(client, Prop_Send, "m_flCloakMeter", cloakMeter*1.0);
}

/////////////////////////////////////////////////////////////////////
//
// Hype[^[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerHypeMeter(client)
{
    return RoundFloat(GetEntPropFloat(client, Prop_Send, "m_flHypeMeter"));

}

/////////////////////////////////////////////////////////////////////
//
// Hype[^[ݒ
//
/////////////////////////////////////////////////////////////////////
stock TF2_SetPlayerHypeMeter(client, amount)
{
	if( amount < 0 )
	{
		amount = 0;
	}
	if( amount > 100 )
	{
		amount = 100;
	}
	SetEntPropFloat(client, Prop_Send, "m_flHypeMeter", amount*1.0);
}

/////////////////////////////////////////////////////////////////////
//
// Drink[^[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerDrinkMeter(client)
{
    return RoundFloat(GetEntPropFloat(client, Prop_Send, "m_flEnergyDrinkMeter"));
}

/////////////////////////////////////////////////////////////////////
//
// Drink[^[ݒ
//
/////////////////////////////////////////////////////////////////////
stock TF2_SetPlayerDrinkMeter(client, amount)
{

	if( amount < 0 )
	{
		amount = 0;
	}
	if( amount > 100 )
	{
		amount = 100;
	}
	SetEntPropFloat(client, Prop_Send, "m_flEnergyDrinkMeter", amount*1.0);
}

/////////////////////////////////////////////////////////////////////
//
// Rage[^[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerRageMeter(client)
{
    return RoundFloat(GetEntPropFloat(client, Prop_Send, "m_flRageMeter"));
}

/////////////////////////////////////////////////////////////////////
//
// Rage[^[ݒ
//
/////////////////////////////////////////////////////////////////////
stock TF2_SetPlayerRageMeter(client, amount)
{
	if( amount < 0 )
	{
		amount = 0;
	}
	if( amount > 100 )
	{
		amount = 100;
	}
	SetEntPropFloat(client, Prop_Send, "m_flRageMeter", amount*1.0);
}


/////////////////////////////////////////////////////////////////////
//
// Charge[^[擾
//
/////////////////////////////////////////////////////////////////////
stock TF2_GetPlayerChargeMeter(client)
{
    return RoundFloat(GetEntPropFloat(client, Prop_Send, "m_flChargeMeter"));
}

/////////////////////////////////////////////////////////////////////
//
// Charge[^[ݒ
//
/////////////////////////////////////////////////////////////////////
stock TF2_SetPlayerChargeMeter(client, amount)
{
	if( amount < 0 )
	{
		amount = 0;
	}
	if( amount > 100 )
	{
		amount = 100;
	}
	SetEntPropFloat(client, Prop_Send, "m_flChargeMeter", amount*1.0);
}

