/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
// 2014.01.04


/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Attack Shield"
#define PL_DESC "Attack Shield"
#define PL_VERSION "2014.01.04"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}

/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_SHIELD_START	"weapons/medi_shield_deploy.wav"
#define SOUND_SHIELD_END	"weapons/medi_shield_retract.wav"


/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
//new Handle:g_CVarCripSize		= INVALID_HANDLE;		// ConVarNbvTCY

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new bool:g_bUseShield[MAXPLAYERS+1] = false;		// [o[xgp?
new g_ShieldEntity[MAXPLAYERS+1] = -1;				// V[hGeBeB

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Medic );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Quick-Fix", "0");

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
//	AddCustomAttributes( IS_Secondary, "clip size penalty", "0.5");	

}

/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );
	
	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
//	AddCVar( g_CVarCripSize,		"clip_size",		"0.125",	"clip size penalty",		0,		"0.1",	"0.9",		FMT_Float);

	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEhvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_SHIELD_START, true);
	PrecacheSound(SOUND_SHIELD_END, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	g_bUseShield[client] = false;
	DeleteShield( client );
	return Plugin_Continue;
}


/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame( )
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{		
			/////////////////////////////////////////////////////////////////////
			// AreBI
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{
				/////////////////////////////////////////////////////////////////////
				// `[W
				/////////////////////////////////////////////////////////////////////
				if( TF2_IsPlayerChargeReleased( client ) )
				{	
					if(TF2_CurrentWeaponEqual(client, "CWeaponMedigun"))
					{					
						if( g_ShieldEntity[client] <= 0 )
						{
							new shield = CreateEntityByName("entity_medigun_shield");
							if(shield != -1)
							{
								DispatchSpawn(shield);
								SetEntPropEnt(shield, Prop_Send, "m_hOwnerEntity", client);  
								SetEntProp(shield, Prop_Send, "m_iTeamNum", GetClientTeam(client)); 
								SetEntProp(shield, Prop_Send, "m_nSkin", GetClientTeam(client) - 2); 
								g_ShieldEntity[client] = shield;
								
								if( TF2_GetPlayerUberLevel(client) > 99 )
								{
									EmitSoundToClient(client, SOUND_SHIELD_START, client, _, _, SND_CHANGEPITCH, 1.0, 100);
									/////////////////////////////////////////////////////////////////////
									// ~jNbc
									/////////////////////////////////////////////////////////////////////
									TF2_AddCondition(client, TFCond_MarkedForDeathSilent, 10.0);
								}
							}
						}
						
						if( TF2_GetPlayerUberLevel(client) == 25)
						{
							EmitSoundToClient(client, SOUND_SHIELD_END, client, _, _, SND_CHANGEPITCH, 1.0, 100);
						}					
						g_bUseShield[client] = true;
						return;
					}
				}
			}
			if( g_bUseShield[client] )
			{
				DeleteShield(client);
				g_bUseShield[client] = false;
			}		
		}

	}
}


/////////////////////////////////////////////////////////////////////
//
// V[h폜
//
/////////////////////////////////////////////////////////////////////
stock DeleteShield(any:client)
{
	// V[h폜
	if( g_ShieldEntity[client] != -1 && g_ShieldEntity[client] != 0)
	{
		if( IsValidEntity(g_ShieldEntity[client]) )
		{
			ActivateEntity(g_ShieldEntity[client]);
			AcceptEntityInput(g_ShieldEntity[client], "Kill");
			g_ShieldEntity[client] = -1;
		}	
	}
}