/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Drunk Bomb"
#define PL_DESC "DrunkBomb"
#define PL_VERSION "2013.02.03"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define MDL_BIG_BOMB "models/props_td/atom_bomb.mdl"
#define SOUND_DEMO_BEEP "items/cart_explode_trigger.wav"
#define SOUND_DEMO_SING "vo/taunts/demoman_taunts01.wav"
#define SOUND_DEMO_EXPLOSION "items/cart_explode.wav"
#define SOUND_DEMO_EXPLOSION_MISS "weapons/explode2.wav"

#define EFFECT_EXPLODE_EMBERS "cinefx_goldrush_embers"
#define EFFECT_EXPLODE_DEBRIS "cinefx_goldrush_debris"
#define EFFECT_EXPLODE_INITIAL_SMOKE "cinefx_goldrush_initial_smoke"
#define EFFECT_EXPLODE_FLAMES "cinefx_goldrush_flames"
#define EFFECT_EXPLODE_FLASH "cinefx_goldrush_flash"
#define EFFECT_EXPLODE_BURNINGDEBIS "cinefx_goldrush_burningdebris"
#define EFFECT_EXPLODE_SMOKE "cinefx_goldrush_smoke"
#define EFFECT_EXPLODE_HUGEDUSTUP "cinefx_goldrush_hugedustup"

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new bool:g_ActionUse[MAXPLAYERS+1] = false;		// ANVACe
new g_BombModel[MAXPLAYERS+1] = -1;				// ef

new Handle:g_FuseTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// t[Y^C}[
new Handle:g_TauntTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// `FbN^C}[

new bool:g_HasBomb[MAXPLAYERS+1] = false;					// `H


/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_DemoMan );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "TF_WEAPON_GRENADELAUNCHER", "0" );
	AddReqItems( "The Loch-n-Load", "0" );
	AddReqItems( "The Loose Cannon", "0" );
	AddReqItems( "TF_WEAPON_BOTTLE", "0" );
	AddReqItems( "The Scottish Handshake", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	//AddCustomAttributes( IS_Primary, "attack projectiles", "1");
}


/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S

	/////////////////////////////////////////////////////////////////////
	// R}ho^
	/////////////////////////////////////////////////////////////////////
	RegConsoleCmd("taunt", Command_Taunt, "taunt");
	RegConsoleCmd("+taunt", Command_Taunt, "taunt");
	
	/////////////////////////////////////////////////////////////////////
	// ActionItemR}ho^
	/////////////////////////////////////////////////////////////////////
	RegConsoleCmd("use_action_slot_item_server", Command_ActionItem);

}


/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEh,fvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheModel(MDL_BIG_BOMB, true);
	PrecacheSound(SOUND_DEMO_BEEP, true);
	PrecacheSound(SOUND_DEMO_SING, true);
	PrecacheSound(SOUND_DEMO_EXPLOSION, true);
	PrecacheSound(SOUND_DEMO_EXPLOSION_MISS, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// L[Ԃۑ
	/////////////////////////////////////////////////////////////////////
	SaveKeyTime(client);	
	
	
	
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	g_ActionUse[client] = false;
	
	// ^C}[NA
	ClearTimer(g_TauntTimer[client]);
	ClearTimer(g_FuseTimer[client]);
	// 
	g_HasBomb[client] = false;
	
	
	/////////////////////////////////////////////////////////////////////
	// KvȂ
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		/////////////////////////////////////////////////////////////////////
		// e폜
		/////////////////////////////////////////////////////////////////////
		DeleteBigBomb(i)
	}
	
	/////////////////////////////////////////////////////////////////////
	// ̂Ƃ߂
	/////////////////////////////////////////////////////////////////////
	StopSound(client, 0, SOUND_DEMO_SING);

	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// w̔e
//
/////////////////////////////////////////////////////////////////////
stock EquipmentBigBomb(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// wɔew
	/////////////////////////////////////////////////////////////////////
	g_BombModel[client] = CreateEntityByName("prop_dynamic");
	if (IsValidEdict(g_BombModel[client]))
	{
        decl String:Buffer[64];
        Format(Buffer, sizeof(Buffer), "Client%d", client);
        DispatchKeyValue(client, "targetname", Buffer);

		new String:tName[32];
		GetEntPropString(client, Prop_Data, "m_iName", tName, sizeof(tName));
		DispatchKeyValue(g_BombModel[client], "targetname", "back_bomb");
		DispatchKeyValue(g_BombModel[client], "parentname", tName);
		if( TFTeam:GetClientTeam(client) == TFTeam_Red)
		{
			SetEntityModel(g_BombModel[client], MDL_BIG_BOMB);
			SetEntityRenderColor(g_BombModel[client], 255, 0, 0, 255)
		}
		else
		{
			SetEntityModel(g_BombModel[client], MDL_BIG_BOMB);
			SetEntityRenderColor(g_BombModel[client], 0, 0, 255, 255)
		}
		DispatchSpawn(g_BombModel[client]);
		SetVariantString("!activator");
		AcceptEntityInput(g_BombModel[client], "SetParent", client, client, 0);
		SetVariantString("flag");
		AcceptEntityInput(g_BombModel[client], "SetParentAttachment", client, client, 0);
		//ActivateEntity(g_BombModel[client]);
//		SetVariantString(Buffer);
//        AcceptEntityInput(g_BombModel[client], "SetParent", client, client, 0);

		new Float:pos[3];
		new Float:ang[3];
		pos[0] = 0.0;
		pos[1] = 15.0;
		pos[2] = 15.0;
		ang[0] = 25.0;
		ang[1] = 90.0;
		ang[2] = -10.0;

	    //TeleportEntity(g_BombModel[client], pos, NULL_VECTOR, NULL_VECTOR);
		//TeleportEntity(g_BombModel[client], pos, ang, NULL_VECTOR);
		//AcceptEntityInput(g_BombModel[client], "start");

    }		
}

/////////////////////////////////////////////////////////////////////
//
// w̔e폜
//
/////////////////////////////////////////////////////////////////////
stock DeleteBigBomb(any:client)
{
//	return;
	// ẽf폜
	if( g_BombModel[client] != -1 && g_BombModel[client] != 0)
	{
		if( IsValidEntity(g_BombModel[client]) )
		{
			ActivateEntity(g_BombModel[client]);
			AcceptEntityInput(g_BombModel[client], "Kill");
			g_BombModel[client] = -1;
		}	
	}
}

/////////////////////////////////////////////////////////////////////
//
// R}h擾
//
/////////////////////////////////////////////////////////////////////
public Action:Command_Taunt(client, args)
{
	/////////////////////////////////////////////////////////////////////
	// AreBgp
	/////////////////////////////////////////////////////////////////////
	if( IsSelectedAbility( client ) )
	{
		if( !TF2_IsPlayerInCondition(client, TFCond_Taunting) && !g_ActionUse[client] )
		{
			/////////////////////////////////////////////////////////////////////
			// q[YOFF
			/////////////////////////////////////////////////////////////////////
			if( g_FuseTimer[client] == INVALID_HANDLE )
			{
				TauntCheck(client);
			}
			
		}
	}	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// `FbN
//
/////////////////////////////////////////////////////////////////////
public TauntCheck( client )
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		/////////////////////////////////////////////////////////////////////
		// ܂΂ĂȂ
		/////////////////////////////////////////////////////////////////////
		if( !g_HasBomb[client]  )
		{
			/////////////////////////////////////////////////////////////////////
			// ߐ
			/////////////////////////////////////////////////////////////////////
			if( GetItemSlot( GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon") ) == 2 )
			{
				/////////////////////////////////////////////////////////////////////
				// ^C}[
				/////////////////////////////////////////////////////////////////////
				//PrintToChat(client,"TauntCheck - bottle");
				ClearTimer(g_TauntTimer[client]);
				g_TauntTimer[client] = CreateTimer(4.3, Timer_TauntEnd, client);
			}
		}
		else 
		{
			/////////////////////////////////////////////////////////////////////
			// vC}
			/////////////////////////////////////////////////////////////////////
			if( GetItemSlot( GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon") ) == 0 )
			{
				/////////////////////////////////////////////////////////////////////
				// ^C}[
				/////////////////////////////////////////////////////////////////////
				//PrintToChat(client,"TauntCheck - grenade");
				ClearTimer(g_TauntTimer[client]);
				g_TauntTimer[client] = CreateTimer(2.0, Timer_TauntEnd, client);
			}		
			
		}
	}
	return;
}

/////////////////////////////////////////////////////////////////////
//
// I^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_TauntEnd(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		/////////////////////////////////////////////////////////////////////
		// ^Egp
		/////////////////////////////////////////////////////////////////////
		if(TF2_IsPlayerInCondition(client, TFCond_Taunting))
		{
			/////////////////////////////////////////////////////////////////////
			// ĂȂ
			/////////////////////////////////////////////////////////////////////
			if( !g_HasBomb[client] )
			{			
				/////////////////////////////////////////////////////////////////////
				// ߐ
				/////////////////////////////////////////////////////////////////////
				if( GetItemSlot( GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon") ) == 2 )
				{
					//PrintToChat(client,"Timer_TauntEnd - Fuse start");
					/////////////////////////////////////////////////////////////////////
					// eX^[g
					/////////////////////////////////////////////////////////////////////
					BombTimerStart(client);
				}
			}
			/////////////////////////////////////////////////////////////////////
			// 
			/////////////////////////////////////////////////////////////////////
			else
			{
				/////////////////////////////////////////////////////////////////////
				// vC}
				/////////////////////////////////////////////////////////////////////
				if( GetItemSlot( GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon") ) == 0 )
				{
					/////////////////////////////////////////////////////////////////////
					// GtFNg
					/////////////////////////////////////////////////////////////////////
					ExplodeEffect(client);
					
					/////////////////////////////////////////////////////////////////////
					// 
					/////////////////////////////////////////////////////////////////////
					g_HasBomb[client] = false;
					
					/////////////////////////////////////////////////////////////////////
					// 
					/////////////////////////////////////////////////////////////////////
					new Float:bombPos[3];
					GetEntPropVector( client, Prop_Data, "m_vecAbsOrigin", bombPos);
					bombPos[2] += 50.0;
					RadiusDamage( client, bombPos, 1500, 64|1048576, 5.0 );
					RadiusDamageBuiltObject( client, bombPos, 1500, 64|1048576, 5.0 );
					
					FakeClientCommand( client, "explode");
				}
			}
			
		}
	}
	g_TauntTimer[client] = INVALID_HANDLE;	
}

/////////////////////////////////////////////////////////////////////
//
// ͈̓_[W
//
/////////////////////////////////////////////////////////////////////
stock RadiusDamage( _attacker, Float:_originPos[3], _damageAmount, _damageType, Float:_radius, Float:_distAttenuation = 1.0 )
{
	/////////////////////////////////////////////////////////////////////
	// Ă
	/////////////////////////////////////////////////////////////////////
	if( IsValidClient( _attacker, false ) && IsPlayerAlive(_attacker) )
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		new maxclients = GetMaxClients();
		for (new client = 1; client <= maxclients; client++)
		{
			/////////////////////////////////////////////////////////////////////
			// Ă
			/////////////////////////////////////////////////////////////////////
			if( IsValidClient( client, false ) && IsPlayerAlive(client) )
			{
				/////////////////////////////////////////////////////////////////////
				// NCAgʒu
				/////////////////////////////////////////////////////////////////////
				new Float:clientPos[3];
				GetEntPropVector( client, Prop_Data, "m_vecAbsOrigin", clientPos);
				clientPos[2] += 50.0;
				
				/////////////////////////////////////////////////////////////////////
				// ͈͓
				/////////////////////////////////////////////////////////////////////
				new Float:dist = GetVectorDistanceMeter( _originPos, clientPos );
				//PrintToChat( _attacker, "dist=%f", dist);
				if( dist <= _radius && GetClientTeam( _attacker ) != GetClientTeam( client ) )
				{
					/////////////////////////////////////////////////////////////////////
					// Q҂A^bJ[܂ŏQȂOK
					/////////////////////////////////////////////////////////////////////
					new hitEnt = -1;
					new bool:bHit = HitCheck(clientPos, NULL_VECTOR, _originPos, MASK_SHOT, hitEnt, RadiusDamageTraceFilter, 0 );
					//PrintToChat( _attacker, "bHit=%d client=%d hitEnt=%d", bHit, client, hitEnt);

					/////////////////////////////////////////////////////////////////////
					// _[W
					/////////////////////////////////////////////////////////////////////
					if( !bHit )
					{
						//PrintToChat( _attacker, "danage=%f", _damageAmount * Pow(_distAttenuation, dist));
						//TF2_AddCondition(client, TFCond_DefenseBuffMmmph, 2.0);
						
						DoDamage(client, _attacker, RoundFloat(_damageAmount * Pow(_distAttenuation, dist)), _damageType);
						
					}
				}
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// ͈̓_[Wij
//
/////////////////////////////////////////////////////////////////////
stock RadiusDamageBuiltObject( _attacker, Float:_originPos[3], _damageAmount, _damageType, Float:_radius, Float:_distAttenuation = 1.0 )
{
	/////////////////////////////////////////////////////////////////////
	// ݒuĂZg[K
	/////////////////////////////////////////////////////////////////////
	new ent = -1;
	while ((ent = FindEntityByClassname(ent, "obj_sentrygun")) != -1)
	{

		/////////////////////////////////////////////////////////////////////
		// ݒuʒu
		/////////////////////////////////////////////////////////////////////
		new Float:objPos[3];
		GetEntPropVector( ent, Prop_Data, "m_vecAbsOrigin", objPos);
		objPos[2] += 50.0;
		
		/////////////////////////////////////////////////////////////////////
		// ͈͓
		/////////////////////////////////////////////////////////////////////
		new Float:dist = GetVectorDistanceMeter( _originPos, objPos );
		//PrintToChat( _attacker, "dist=%f", dist);
		if( dist <= _radius )
		{
			
			/////////////////////////////////////////////////////////////////////
			// G`[̌
			/////////////////////////////////////////////////////////////////////
			new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
			if( GetClientTeam( iOwner ) != GetClientTeam( _attacker ) )
			{		
				/////////////////////////////////////////////////////////////////////
				// A^bJ[܂ŏQȂOK
				/////////////////////////////////////////////////////////////////////
				new hitEnt = -1;
				new bool:bHit = HitCheck(objPos, NULL_VECTOR, _originPos, MASK_SHOT, hitEnt, RadiusDamageTraceFilter, 0 );
				//PrintToChat( _attacker, "bHit=%d client=%d hitEnt=%d", bHit, ent, hitEnt);

				/////////////////////////////////////////////////////////////////////
				// _[W
				/////////////////////////////////////////////////////////////////////
				if( !bHit )
				{
					/////////////////////////////////////////////////////////////////////
					// ۂɂɃ_[W
					/////////////////////////////////////////////////////////////////////
					DoDamageBuilt(ent, _attacker, RoundFloat( _damageAmount * Pow(_distAttenuation, dist) ), _damageType);
				}
				
				
			}
			
		}		
	}
	
	/////////////////////////////////////////////////////////////////////
	// ݒuĂfBXyT[
	/////////////////////////////////////////////////////////////////////
	ent = -1;
	while ((ent = FindEntityByClassname(ent, "obj_dispenser")) != -1)
	{

		/////////////////////////////////////////////////////////////////////
		// ݒuʒu
		/////////////////////////////////////////////////////////////////////
		new Float:objPos[3];
		GetEntPropVector( ent, Prop_Data, "m_vecAbsOrigin", objPos);
		objPos[2] += 50.0;
		
		/////////////////////////////////////////////////////////////////////
		// ͈͓
		/////////////////////////////////////////////////////////////////////
		new Float:dist = GetVectorDistanceMeter( _originPos, objPos );
		//PrintToChat( _attacker, "dist=%f", dist);
		if( dist <= _radius )
		{
			
			/////////////////////////////////////////////////////////////////////
			// G`[̌
			/////////////////////////////////////////////////////////////////////
			new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
			if( GetClientTeam( iOwner ) != GetClientTeam( _attacker ) )
			{		
				/////////////////////////////////////////////////////////////////////
				// A^bJ[܂ŏQȂOK
				/////////////////////////////////////////////////////////////////////
				new hitEnt = -1;
				new bool:bHit = HitCheck(objPos, NULL_VECTOR, _originPos, MASK_SHOT, hitEnt, RadiusDamageTraceFilter, 0 );

				/////////////////////////////////////////////////////////////////////
				// _[W
				/////////////////////////////////////////////////////////////////////
				if( !bHit )
				{
					/////////////////////////////////////////////////////////////////////
					// ۂɂɃ_[W
					/////////////////////////////////////////////////////////////////////
					DoDamageBuilt(ent, _attacker, RoundFloat( _damageAmount * Pow(_distAttenuation, dist) ), _damageType);
				}
				
				
			}
			
		}		
	}	
	/////////////////////////////////////////////////////////////////////
	// ݒuĂe|[^[
	/////////////////////////////////////////////////////////////////////
	ent = -1;
	while ((ent = FindEntityByClassname(ent, "obj_teleporter")) != -1)
	{

		/////////////////////////////////////////////////////////////////////
		// ݒuʒu
		/////////////////////////////////////////////////////////////////////
		new Float:objPos[3];
		GetEntPropVector( ent, Prop_Data, "m_vecAbsOrigin", objPos);
		objPos[2] += 50.0;
		
		/////////////////////////////////////////////////////////////////////
		// ͈͓
		/////////////////////////////////////////////////////////////////////
		new Float:dist = GetVectorDistanceMeter( _originPos, objPos );
		//PrintToChat( _attacker, "dist=%f", dist);
		if( dist <= _radius )
		{
			
			/////////////////////////////////////////////////////////////////////
			// G`[̌
			/////////////////////////////////////////////////////////////////////
			new iOwner = GetEntPropEnt(ent, Prop_Send, "m_hBuilder");
			if( GetClientTeam( iOwner ) != GetClientTeam( _attacker ) )
			{		
				/////////////////////////////////////////////////////////////////////
				// A^bJ[܂ŏQȂOK
				/////////////////////////////////////////////////////////////////////
				new hitEnt = -1;
				new bool:bHit = HitCheck(objPos, NULL_VECTOR, _originPos, MASK_SHOT, hitEnt, RadiusDamageTraceFilter, 0 );

				/////////////////////////////////////////////////////////////////////
				// _[W
				/////////////////////////////////////////////////////////////////////
				if( !bHit )
				{
					/////////////////////////////////////////////////////////////////////
					// ۂɂɃ_[W
					/////////////////////////////////////////////////////////////////////
					DoDamageBuilt(ent, _attacker, RoundFloat( _damageAmount * Pow(_distAttenuation, dist) ), _damageType);
				}
				
				
			}
			
		}		
	}		
	
	
	
}

/////////////////////////////////////////////////////////////////////
//
// _[W
//
/////////////////////////////////////////////////////////////////////
stock DoDamageBuilt(any:obj, _attacker, _damageAmount, _damageType)
{

	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if(	TF2_EdictNameEqual(obj, "obj_dispenser") ||
		TF2_EdictNameEqual(obj, "obj_sentrygun") || 	
		TF2_EdictNameEqual(obj, "obj_teleporter")) 	
	{		
		new pointHurt = CreateEntityByName("point_hurt");
		if (pointHurt)
		{
			DispatchKeyValue(obj, "targetname", "doDamage");
			DispatchKeyValue(pointHurt, "DamageTarget", "doDamage");
			new String:dmg[15];
			Format(dmg, 15, "%i", _damageAmount);
			DispatchKeyValue(pointHurt, "Damage", dmg);
			new String:dmgType[15];
			Format(dmgType, 15, "%i", _damageType);
			DispatchKeyValue(pointHurt, "DamageType", dmgType);

			DispatchSpawn(pointHurt);
			AcceptEntityInput(pointHurt, "Hurt", _attacker);
			DispatchKeyValue(pointHurt, "classname", "point_hurt");
			DispatchKeyValue(obj, "targetname", "");
			RemoveEdict(pointHurt);
		}					
	}	
	
	/////////////////////////////////////////////////////////////////////
	// IuWFNg
	/////////////////////////////////////////////////////////////////////
//	if(	TF2_EdictNameEqual(building, "obj_dispenser") ||
//		TF2_EdictNameEqual(building, "obj_sentrygun") || 
//		TF2_EdictNameEqual(building, "obj_teleporter")) 
//	{	
//	
//		/////////////////////////////////////////////////////////////////////
//		// ۂɂɃ_[W
//		/////////////////////////////////////////////////////////////////////
//		SetVariantInt( _damageAmount );
//		AcceptEntityInput( obj, "RemoveHealth");					
//		
//	}
}



/////////////////////////////////////////////////////////////////////
//
// g[XtB^
//
/////////////////////////////////////////////////////////////////////
public bool:RadiusDamageTraceFilter( entity, contentsMask, any:data )
{
	new String:entName[64];
	GetEntityClassname(entity, entName, sizeof(entName));
//	PrintToServer("entity = %d %s", entity, entName);

	return entity > MAXPLAYERS && !StrEqual( entName, "obj_sentrygun") && !StrEqual( entName, "obj_dispenser") && !StrEqual( entName, "obj_teleporter");
}

/////////////////////////////////////////////////////////////////////
//
// _[W
//
/////////////////////////////////////////////////////////////////////
stock DoDamage(any:client, _attacker, _damageAmount, _damageType)
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		new pointHurt = CreateEntityByName("point_hurt");
		if (pointHurt)
		{
			DispatchKeyValue(client, "targetname", "doDamage");
			DispatchKeyValue(pointHurt, "DamageTarget", "doDamage");
			new String:dmg[15];
			Format(dmg, 15, "%i", _damageAmount);
			DispatchKeyValue(pointHurt, "Damage", dmg);
			new String:dmgType[15];
			Format(dmgType, 15, "%i", _damageType);
			DispatchKeyValue(pointHurt, "DamageType", dmgType);

			DispatchSpawn(pointHurt);
			AcceptEntityInput(pointHurt, "Hurt", _attacker);
			DispatchKeyValue(pointHurt, "classname", "point_hurt");
			DispatchKeyValue(client, "targetname", "");
			RemoveEdict(pointHurt);
		}					
	}
}









/////////////////////////////////////////////////////////////////////
//
// eX^[g
//
/////////////////////////////////////////////////////////////////////
stock BombTimerStart(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		//PrintToChat(client,"BombTimerStart - TimerStart");
		/////////////////////////////////////////////////////////////////////
		// 
		/////////////////////////////////////////////////////////////////////
		g_HasBomb[client] = true;
		
		/////////////////////////////////////////////////////////////////////
		// t[Y
		/////////////////////////////////////////////////////////////////////
		ClearTimer(g_FuseTimer[client]);
		g_FuseTimer[client] = CreateTimer(5.5, Timer_FuseEnd, client);
		
		/////////////////////////////////////////////////////////////////////
		// TEh()
		/////////////////////////////////////////////////////////////////////
		EmitSoundToAll(SOUND_DEMO_BEEP, client, _, _, SND_CHANGEPITCH, 1.0, 100);
		EmitSoundToAll(SOUND_DEMO_SING, client, _, _, SND_CHANGEPITCH, 1.0, 100);

		/////////////////////////////////////////////////////////////////////
		// ԕύX
		/////////////////////////////////////////////////////////////////////
		TF2_StunPlayer( client, 15.0, _, TF_STUNFLAG_NOSOUNDOREFFECT|TF_STUNFLAG_THIRDPERSON, client);
		TF2_AddCondition(client, TFCond_DefenseBuffMmmph, 15.0);	
		
		/////////////////////////////////////////////////////////////////////
		// e
		/////////////////////////////////////////////////////////////////////
		EquipmentBigBomb(client);		
	}
}

/////////////////////////////////////////////////////////////////////
//
// t[YII^C}[[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_FuseEnd(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		/////////////////////////////////////////////////////////////////////
		// ̂Ƃ߂
		/////////////////////////////////////////////////////////////////////
		StopSound(client, 0, SOUND_DEMO_SING);
		
		/////////////////////////////////////////////////////////////////////
		// nʂɂȂOR^EgȂ烋[v
		/////////////////////////////////////////////////////////////////////
		if( !( GetEntityFlags(client) & FL_ONGROUND ) || TF2_IsPlayerInCondition(client, TFCond_Taunting))
		{
			/////////////////////////////////////////////////////////////////////
			// t[Y
			/////////////////////////////////////////////////////////////////////
			ClearTimer(g_FuseTimer[client]);
			g_FuseTimer[client] = CreateTimer(0.5, Timer_FuseEnd, client);
			
			/////////////////////////////////////////////////////////////////////
			// ԕω
			/////////////////////////////////////////////////////////////////////
			//TF2_StunPlayer( client, 2.0, _, TF_STUNFLAG_NOSOUNDOREFFECT|TF_STUNFLAG_THIRDPERSON, client);
			//TF2_AddCondition(client, TFCond_DefenseBuffMmmph, 2.0);	
			return;
		}
		else
		{
			/////////////////////////////////////////////////////////////////////
			// vC}
			/////////////////////////////////////////////////////////////////////
			new weaponid = GetPlayerWeaponSlot(client, 0);
			SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", weaponid);
			ClientCommand(client, "taunt");
			
			/////////////////////////////////////////////////////////////////////
			// ^C}[
			/////////////////////////////////////////////////////////////////////
			//PrintToChat(client,"TauntCheck - grenade");
			ClearTimer(g_TauntTimer[client]);
			g_TauntTimer[client] = CreateTimer(2.0, Timer_TauntEnd, client);		
		}

		
		
		// _[W`FbN
//		RadiusDamageBuiltObject(client, 0);
//		RadiusDamageBuiltObject(client, 1);
//		RadiusDamageBuiltObject(client, 2);
//		RadiusDamageBuiltObject(client, 3);
//		RadiusDamage(client);
		
//		if( g_BombModel[client] != -1 )
//		{
//			if( IsValidEntity(g_BombModel[client]) )
//			{
//				ActivateEntity(g_BombModel[client]);
//				AcceptEntityInput(g_BombModel[client], "Kill");
//				g_BombModel[client] = -1;
//			}	
//		}
		
		// EGtFNg폜
		//KillDrug(client);

		 
	}
	g_FuseTimer[client] = INVALID_HANDLE;
}

/////////////////////////////////////////////////////////////////////
//
// GtFNg
//
/////////////////////////////////////////////////////////////////////
public ExplodeEffect(any:client)
{
	EmitSoundToAll(SOUND_DEMO_EXPLOSION, client, _, _, SND_CHANGEPITCH, 0.8, 200);
	new Float:ang[3];
	ang[0] = -90.0;
	ang[1] = 0.0;
	ang[2] = 0.0;
	new Float:pos[3];
	pos[0] = 0.0;
	pos[1] = 0.0;
	pos[2] = 50.0;	
	
	SpawnParticle(EFFECT_EXPLODE_EMBERS,		1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_DEBRIS,		1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_INITIAL_SMOKE,	1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_FLAMES,		1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_FLASH,			1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_BURNINGDEBIS,	1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_SMOKE,			1.0, _, client, _, pos, ang);
	SpawnParticle(EFFECT_EXPLODE_HUGEDUSTUP,	1.0, _, client, _, pos, ang);
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// ACeIOFF
			/////////////////////////////////////////////////////////////////////
			if( g_ActionUse[client] )
			{
				if( !TF2_IsPlayerInCondition(client, TFCond_Taunting) )
				{
					g_ActionUse[client] = false;
				}
			}
			
//			/////////////////////////////////////////////////////////////////////
//			// `FbN
//			/////////////////////////////////////////////////////////////////////
//			if( CheckElapsedTime(client, 0.8) )
//			{			
//				/////////////////////////////////////////////////////////////////////
//				// L[Ԃۑ
//				/////////////////////////////////////////////////////////////////////
//				if( GetClientButtons(client) & IN_ATTACK )
//				{				
//					/////////////////////////////////////////////////////////////////////
//					// L[Ԃۑ
//					/////////////////////////////////////////////////////////////////////
//					SaveKeyTime(client);
//					/////////////////////////////////////////////////////////////////////
//					// 
//					/////////////////////////////////////////////////////////////////////
//					PrintToChat(client, "press");
//					
//					//_[W`FbN
//					new Float:bombPos[3];
//					GetEntPropVector( client, Prop_Data, "m_vecAbsOrigin", bombPos);
//					bombPos[2] += 50.0;
//					RadiusDamage( client, bombPos, 1500, 64|1048576, 5.0 );
//					RadiusDamageBuiltObject( client, bombPos, 1500, 64|1048576, 5.0 );
//					
//				}
//			}			
			
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// ANVXbg
//
/////////////////////////////////////////////////////////////////////
public Action:Command_ActionItem(client, args)
{
	if( IsRunning() )
	{
		/////////////////////////////////////////////////////////////////////
		// ANVACegp
		/////////////////////////////////////////////////////////////////////
		g_ActionUse[client] = true;
	}
	return Plugin_Continue;
}