/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
// 2013.03.10


/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Original Quick-Fix"
#define PL_DESC "Original Quick-Fix"
#define PL_VERSION "2013.03.10"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}

/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_UBER_START	"mvm/mvm_tele_activate.wav"
#define SOUND_UBER_SHORT	"mvm/mvm_tele_deliver.wav"


/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
//new Handle:g_CVarCripSize		= INVALID_HANDLE;		// ConVarNbvTCY

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new bool:g_bUsedCharge[MAXPLAYERS+1] = false;		// [o[xgp?
new bool:g_bShortedQF[MAXPLAYERS+1] = false;		// Quick-FixԂꂽ

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Medic );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Quick-Fix", "0");
}

/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );
	
	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
//	AddCVar( g_CVarCripSize,		"clip_size",		"0.125",	"clip size penalty",		0,		"0.1",	"0.9",		FMT_Float);

	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEhvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_UBER_START, true);
	PrecacheSound(SOUND_UBER_SHORT, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	g_bUsedCharge[client] = false;
	g_bShortedQF[client] = false;
	
	return Plugin_Continue;
}


/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame( )
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{		
			/////////////////////////////////////////////////////////////////////
			// AreBI
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{
				/////////////////////////////////////////////////////////////////////
				// V[ƂĂȂ
				/////////////////////////////////////////////////////////////////////
				if( !g_bShortedQF[client] )
				{					
					/////////////////////////////////////////////////////////////////////
					// `[W
					/////////////////////////////////////////////////////////////////////
					if( TF2_IsPlayerChargeReleased( client ) )
					{					
						/////////////////////////////////////////////////////////////////////
						// 񕜑ΏێҎ擾
						/////////////////////////////////////////////////////////////////////
						new target = TF2_GetHealingTarget( client );
						
						/////////////////////////////////////////////////////////////////////
						// 񕜑Ώێ҂
						/////////////////////////////////////////////////////////////////////
						if( target != -1 )
						{
							/////////////////////////////////////////////////////////////////////
							// CQ[
							/////////////////////////////////////////////////////////////////////
							if( IsValidClient( target, false ) && IsPlayerAlive( target ) )
							{
								TF2_AddCondition( target, TFCond_UberchargeFading, 1.5);
								TF2_AddCondition( target, TFCond_Ubercharged, 1.0);
								
								/////////////////////////////////////////////////////////////////////
								// TEh(^[Qbg)
								/////////////////////////////////////////////////////////////////////
								if( !g_bUsedCharge[client] )
								{
									EmitSoundToClient(target, SOUND_UBER_START, client, _, _, SND_CHANGEPITCH, 0.3, 120);
								}
							}
						}
						
						/////////////////////////////////////////////////////////////////////
						// TEh(fBbN)
						/////////////////////////////////////////////////////////////////////
						if( !g_bUsedCharge[client] )
						{
							EmitSoundToClient(client, SOUND_UBER_START, client, _, _, SND_CHANGEPITCH, 0.3, 120);
						}

						/////////////////////////////////////////////////////////////////////
						// 
						/////////////////////////////////////////////////////////////////////
						g_bUsedCharge[client] = true;
						
						/////////////////////////////////////////////////////////////////////
						// 񃆁[o[IԍۂɃV[g
						/////////////////////////////////////////////////////////////////////
						if( g_bUsedCharge[client] && TF2_GetPlayerUberLevel( client ) <= 1 && !g_bShortedQF[client] )
						{
							g_bShortedQF[client] = true;
							
							/////////////////////////////////////////////////////////////////////
							// V[gTEh
							/////////////////////////////////////////////////////////////////////
							EmitSoundToClient(client, SOUND_UBER_SHORT, client, _, _, SND_CHANGEPITCH, 0.3, 100);
							/////////////////////////////////////////////////////////////////////
							// V[gTEh(^[Qbg)
							/////////////////////////////////////////////////////////////////////
							if( target != -1 )
							{
								EmitSoundToClient(target, SOUND_UBER_SHORT, client, _, _, SND_CHANGEPITCH, 0.3, 100);
							}	
							
							/////////////////////////////////////////////////////////////////////
							// bZ[W
							/////////////////////////////////////////////////////////////////////
							PrintToChat(client, "\x05%T", "MESSAGE_SHORTED", client);
						}
						
					}
				}
			}
		}

	}
}

