/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
// 2013.09.22

/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Ricochet Launcher"
#define PL_DESC "Ricochet Launcher"
#define PL_VERSION "2013.09.22"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_RICOCHET "weapons/saxxy_impact_gen_01.wav"
#define RICOCHET_ROCKETS_MAX	8	// R`FbgPbgő吔
#define RICOCHET_START_COUNT	5	// R`FbgJEgX^[g


/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new g_RocketsData[MAXPLAYERS+1][RICOCHET_ROCKETS_MAX];			// Pbgf[^
new g_RocketRico[MAXPLAYERS+1][RICOCHET_ROCKETS_MAX];			// Pbge
new g_RocketCount[MAXPLAYERS+1][RICOCHET_ROCKETS_MAX];			// PbgJE^

/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
new Handle:g_CVarMaxRicochet	= INVALID_HANDLE;		// ConVarő咵e


/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Soldier );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Liberty Launcher", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	
}

/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarMaxRicochet,	"max_ricochet",	"2",	"Max Ricochet Count",	0, "1",		"99",	FMT_Int);
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		RemoveRocket(i);
	}
	
	/////////////////////////////////////////////////////////////////////
	// TEh,fvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_RICOCHET, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// L[Ԃۑ
	/////////////////////////////////////////////////////////////////////
	SaveKeyTime(client);	
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	RemoveRocket( client );
	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// AreB
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{			
				/////////////////////////////////////////////////////////////////////
				// AreB
				/////////////////////////////////////////////////////////////////////
				RocketRicochet( client );
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// AreB
//
/////////////////////////////////////////////////////////////////////
public RocketRicochet( client )
{

	/////////////////////////////////////////////////////////////////////
	// f[^o^Ă邩`FbN
	/////////////////////////////////////////////////////////////////////
	for(new i = 0; i < RICOCHET_ROCKETS_MAX; i++)
	{				
		if( g_RocketsData[client][i] != -1 )
		{
			/////////////////////////////////////////////////////////////////////
			// PbgΔ
			/////////////////////////////////////////////////////////////////////
			if( IsValidEdict( g_RocketsData[client][i] )
				&& TF2_EdictNameEqual( g_RocketsData[client][i], "tf_projectile_rocket") ) 
			{
				/////////////////////////////////////////////////////////////////////
				// `FbNJnĂ邩mF
				/////////////////////////////////////////////////////////////////////
				if( g_RocketCount[client][i] > 0 )
				{
					g_RocketCount[client][i]--;
				}
				else
				{
					if( g_RocketRico[client][i] > 0 )
					{
						new Float:RocketPos[3];	// Pbg̈ʒu
						new Float:RocketAng[3];	// Pbg̊px
						new Float:RocketVec[3];	// Pbg̕
						new Float:PlaneNorm[3];		// n\m[}

						/////////////////////////////////////////////////////////////////////
						// Pbg̃f[^ǂݍ
						/////////////////////////////////////////////////////////////////////
						GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsOrigin", RocketPos );		// Pbg̈ʒu
						GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_angRotation", RocketAng );		// Pbg̊px
						GetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsVelocity", RocketVec );	// Pbg̕
						new Float:targetPos[3];
						new Float:upVec[3];
						
						
						/////////////////////////////////////////////////////////////////////
						// f[^擾
						/////////////////////////////////////////////////////////////////////
						GetAngleVectors(RocketAng, targetPos, NULL_VECTOR, upVec);
						NormalizeVector(targetPos, targetPos);
						ScaleVector(targetPos, 50.0)
						AddVectors(RocketPos, targetPos, targetPos)
					
						/////////////////////////////////////////////////////////////////////
						// ǃ`FbN
						/////////////////////////////////////////////////////////////////////
						new hitEnt = -1;
						new bool:bHit = HitCheckNorm(RocketPos, NULL_VECTOR, targetPos, PlaneNorm, MASK_SOLID, hitEnt, RicochetFilter, 0 );	
						if( bHit && hitEnt == 0)
						{
							/////////////////////////////////////////////////////////////////////
							// ˃xNg擾
							/////////////////////////////////////////////////////////////////////
							Vec3dReflect( RocketVec, PlaneNorm, RocketVec);
							SetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_vecAbsVelocity", RocketVec );	// Pbg̕
							g_RocketCount[client][i] = RICOCHET_START_COUNT;
							
							/////////////////////////////////////////////////////////////////////
							// Pbg̊px킹
							/////////////////////////////////////////////////////////////////////
							NormalizeVector(RocketVec, RocketAng);
							GetVectorAngles(RocketAng, RocketAng);
							SetEntPropVector( g_RocketsData[client][i], Prop_Data, "m_angRotation", RocketAng );		// Pbg̊px
							
							/////////////////////////////////////////////////////////////////////
							// ˉ
							/////////////////////////////////////////////////////////////////////
							EmitSoundToAll(SOUND_RICOCHET, g_RocketsData[client][i]);
							
							/////////////////////////////////////////////////////////////////////
							// e񐔌炷
							/////////////////////////////////////////////////////////////////////
							g_RocketRico[client][i]--;									
						}
					}
				}
			}
			else
			{
				/////////////////////////////////////////////////////////////////////
				// ɃPbgĂ烊Xg폜
				/////////////////////////////////////////////////////////////////////
				g_RocketsData[client][i] = -1;
				g_RocketRico[client][i] = GetConVarInt( g_CVarMaxRicochet );
				g_RocketCount[client][i] = RICOCHET_START_COUNT;
			}
		}
	}				
}


/////////////////////////////////////////////////////////////////////
//
// ˃xNg
//
/////////////////////////////////////////////////////////////////////
public Vec3dReflect( Float:inVec[3], Float:norVec[3], Float:resultVec[3])
{
	resultVec[0] = -2 * ( norVec[0] * inVec[0] ) * norVec[0] + inVec[0];
	resultVec[1] = -2 * ( norVec[1] * inVec[1] ) * norVec[1] + inVec[1];
	resultVec[2] = -2 * ( norVec[2] * inVec[2] ) * norVec[2] + inVec[2];
	
}


/////////////////////////////////////////////////////////////////////
//
// qbg`FbNiqbgNormaltj
//
/////////////////////////////////////////////////////////////////////
stock bool:HitCheckNorm( const Float:origin[3], const Float:angle[3], Float:lookAt[3] = NULL_VECTOR, Float:planeNorm[3] = NULL_VECTOR, flag, &any:hitEnt, TraceEntityFilter:filterFunc, any:data )
{
	/////////////////////////////////////////////////////////////////////
	// nh쐬
	/////////////////////////////////////////////////////////////////////
	new Handle:hTrace;
	
	/////////////////////////////////////////////////////////////////////
	// wH
	/////////////////////////////////////////////////////////////////////
	if( lookAt[0] != 0.0 || lookAt[1] != 0.0 ||lookAt[2] != 0.0)
	{
		/////////////////////////////////////////////////////////////////////
		// g[X`FbN
		/////////////////////////////////////////////////////////////////////
		hTrace = TR_TraceRayFilterEx( origin, lookAt, flag, RayType_EndPoint, filterFunc, data);
		
	}
	else
	{
		/////////////////////////////////////////////////////////////////////
		// g[X`FbN
		/////////////////////////////////////////////////////////////////////
		hTrace = TR_TraceRayFilterEx( origin, angle, flag, RayType_Infinite, filterFunc, data);
	}
	

	/////////////////////////////////////////////////////////////////////
	// qbgʒu擾
	/////////////////////////////////////////////////////////////////////
	if( TR_DidHit( hTrace ) ) 
	{
		/////////////////////////////////////////////////////////////////////
		// ʒu擾
		/////////////////////////////////////////////////////////////////////
		if( lookAt[0] == 0.0 && lookAt[1] == 0.0 && lookAt[2] == 0.0)
		{
			TR_GetEndPosition( lookAt, hTrace );
		}
		
		/////////////////////////////////////////////////////////////////////
		// qbgGeBeB擾
		/////////////////////////////////////////////////////////////////////
		hitEnt = TR_GetEntityIndex( hTrace );
		
		/////////////////////////////////////////////////////////////////////
		// qbgꏊ̃m[}xN^[
		/////////////////////////////////////////////////////////////////////
		TR_GetPlaneNormal( hTrace, planeNorm);

		CloseHandle( hTrace );
		return true;
	}
	/////////////////////////////////////////////////////////////////////
	// nhN[Y
	/////////////////////////////////////////////////////////////////////
	CloseHandle(hTrace);
	return false;
}
/////////////////////////////////////////////////////////////////////
//
// g[XtB^
//
/////////////////////////////////////////////////////////////////////
public bool:RicochetFilter( entity, contentsMask, any:data )
{
	new String:entName[64];
	GetEntityClassname(entity, entName, sizeof(entName));

//	if( !StrEqual( entName, "tf_projectile_rocket") )
//	{
//		PrintToChatAll("entName=%s", entName);
//	}
	
	return entity <= MAXPLAYERS || StrEqual( entName, "obj_sentrygun") || StrEqual( entName, "obj_dispenser") || StrEqual( entName, "obj_teleporter");
}


/////////////////////////////////////////////////////////////////////
//
// Pbt폜
//
/////////////////////////////////////////////////////////////////////
public RemoveRocket( client )
{
	
	/////////////////////////////////////////////////////////////////////
	// 낢돉
	/////////////////////////////////////////////////////////////////////
	for( new i = 0; i < RICOCHET_ROCKETS_MAX; i++ )
	{
		g_RocketsData[client][i] = -1;
		g_RocketRico[client][i] = GetConVarInt( g_CVarMaxRicochet );
		g_RocketCount[client][i] = RICOCHET_START_COUNT;
	}
	

}

/////////////////////////////////////////////////////////////////////
//
// GeBeB쐬
//
/////////////////////////////////////////////////////////////////////
public OnEntityCreated(entity, const String:classname[])
{
	/////////////////////////////////////////////////////////////////////
	// Pbĝ
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( classname, "tf_projectile_rocket") )
	{
	    SDKHook(entity, SDKHook_Spawn, OnEntitySpawned);
	}
}
public OnEntitySpawned(entity)
{
	/////////////////////////////////////////////////////////////////////
	// Pbĝ
	/////////////////////////////////////////////////////////////////////
	if( TF2_EdictNameEqual( entity, "tf_projectile_rocket")  )
	{
		/////////////////////////////////////////////////////////////////////
		// ˂vC[AreBĂ
		/////////////////////////////////////////////////////////////////////
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		if( IsSelectedAbility( client )  )
		{
			/////////////////////////////////////////////////////////////////////
			// f[^o^Ă邩`FbN
			/////////////////////////////////////////////////////////////////////
			for(new i = 0; i < RICOCHET_ROCKETS_MAX; i++)
			{				
				if( g_RocketsData[client][i] == -1 )
				{
					g_RocketsData[client][i] = entity;
					g_RocketRico[client][i] = GetConVarInt( g_CVarMaxRicochet );
					g_RocketCount[client][i] = RICOCHET_START_COUNT;
					break;
				}
			}				
		}
	}
	SDKUnhook(entity, SDKHook_Spawn, OnEntitySpawned);
}

