/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Sticky Flash"
#define PL_DESC "StickyFlash"
#define PL_VERSION "2012.01.27"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_BOMB_BANG "player/medic_charged_death.wav"
#define SOUND_BOMB_BANG2 "player/pl_impact_airblast2.wav"
#define SOUND_BOMB_SIGNAL "weapons/stickybomblauncher_det.wav"

#define EFFECT_EXPLODE_SMOKE "Explosions_MA_Smoke_1"
#define EFFECT_EXPLODE_DEBRIS "Explosions_MA_Debris001"
#define EFFECT_EXPLODE_FLASH "teleported_flash"
#define EFFECT_PUSE_RED "stickybomb_pulse_red"
#define EFFECT_PUSE_BLU "stickybomb_pulse_blue"

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new Handle:g_TauntTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// `FbN^C}[
new Handle:g_FlashTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// tbVI^C}[
new Handle:g_SoundTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// TEh^C}[
new g_FlashPower[MAXPLAYERS+1] = 0;		// tbVp[
new bool:g_ActionUse[MAXPLAYERS+1] = false;		// ANVACe

/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
new Handle:g_CVarBlindTime = INVALID_HANDLE;						// ConVarڂῂގԃx[X
new Handle:g_CVarBlindTimeNormalAdd = INVALID_HANDLE;				// ConVarڂῂގԒǉ
new Handle:g_CVarBlindTimeCriticalAdd = INVALID_HANDLE;				// ConVarNeBJ̖ڂῂގ


/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarBlindTime,			"base_blindtime",		"1.0",	"Base blind time",			0,		"0.0",	"120.0",		FMT_Float);
	AddCVar( g_CVarBlindTimeNormalAdd,	"blindtime_add",		"0.5",	"Add blind time",			0,		"0.0",	"120.0",		FMT_Float);
	AddCVar( g_CVarBlindTimeCriticalAdd,"blindtime_add_crits",	"2.0",	"Add blind time critical",	0,		"0.0",	"120.0",		FMT_Float);
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S

	/////////////////////////////////////////////////////////////////////
	// R}ho^
	/////////////////////////////////////////////////////////////////////
	RegConsoleCmd("taunt", Command_Taunt, "taunt");
	RegConsoleCmd("+taunt", Command_Taunt, "taunt");
	
	/////////////////////////////////////////////////////////////////////
	// ActionItemR}ho^
	/////////////////////////////////////////////////////////////////////
	RegConsoleCmd("use_action_slot_item_server", Command_ActionItem);

}

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_DemoMan );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Scottish Resistance", "0" );
	
	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
	AddCustomAttributes( IS_Secondary, "clip size penalty", "0.5");	
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// TEh,fvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_BOMB_BANG, true);
	PrecacheSound(SOUND_BOMB_BANG2, true);
	PrecacheSound(SOUND_BOMB_SIGNAL, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_TauntTimer[client]);
	ClearTimer(g_FlashTimer[client]);
	ClearTimer(g_SoundTimer[client]);
	g_FlashPower[client] = 0;
	g_ActionUse[client] = false;
	ScreenFade(client, 255, 255, 255, 0, 0, 0);
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// ACeIOFF
			/////////////////////////////////////////////////////////////////////
			if( g_ActionUse[client] )
			{
				if( !TF2_IsPlayerInCondition(client, TFCond_Taunting) )
				{
					g_ActionUse[client] = false;
				}
			}
			
		}
	}
}


/////////////////////////////////////////////////////////////////////
//
// R}h擾
//
/////////////////////////////////////////////////////////////////////
public Action:Command_Taunt(client, args)
{
	if( IsSelectedAbility( client ) )
	{
		if( !TF2_IsPlayerInCondition(client, TFCond_Taunting) && !g_ActionUse[client] )
		{
			StickyFlash(client);
		}
	}	

	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// 
//
/////////////////////////////////////////////////////////////////////
public StickyFlash(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// XReBbVWX^X
	/////////////////////////////////////////////////////////////////////
	if(GetItemDefIndex( TF2_GetCurrentWeapon(client) ) == 130)
	{

		ClearTimer(g_TauntTimer[client]);
		g_TauntTimer[client] = CreateTimer(3.0, Timer_TauntEnd, client);

		ClearTimer(g_SoundTimer[client]);
		g_SoundTimer[client] = CreateTimer(2.5, Timer_Sound, client);
	}	
}
/////////////////////////////////////////////////////////////////////
//
// TEhI^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_Sound(Handle:timer, any:client)
{
	g_SoundTimer[client] = INVALID_HANDLE;
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		if( TF2_IsPlayerInCondition(client, TFCond_Taunting) && !g_ActionUse[client] )
		{
			/////////////////////////////////////////////////////////////////////
			// TĂS擾
			/////////////////////////////////////////////////////////////////////
			new bool:detect = false;
			new ent = -1;
			while ((ent = FindEntityByClassname(ent, "tf_projectile_pipe_remote")) != -1)
			{
				/////////////////////////////////////////////////////////////////////
				// S̃I[i[
				/////////////////////////////////////////////////////////////////////
				new iOwner = GetEntDataEnt2(ent, FindSendPropInfo("CTFGrenadePipebombProjectile", "m_hThrower"));
				if(iOwner == client)
				{
					if(IsValidEntity(ent))
					{
						/////////////////////////////////////////////////////////////////////
						// 1łtrue
						/////////////////////////////////////////////////////////////////////
						detect = true;
						
						/////////////////////////////////////////////////////////////////////
						// GtFNg
						/////////////////////////////////////////////////////////////////////
						if( GetClientTeam(client) == _:TFTeam_Red )
						{
							SpawnParticle( EFFECT_PUSE_RED, 0.5, _, ent);
						}
						else
						{
							SpawnParticle( EFFECT_PUSE_BLU, 0.5, _, ent);
						}
					}		
				}
			}		
		
			/////////////////////////////////////////////////////////////////////
			// N
			/////////////////////////////////////////////////////////////////////
			if( detect )
			{
				EmitSoundToClient(client, SOUND_BOMB_SIGNAL, client, _, _, SND_CHANGEPITCH, 1.0, 80);
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// I^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_TauntEnd(Handle:timer, any:client)
{
	g_TauntTimer[client] = INVALID_HANDLE;
	/////////////////////////////////////////////////////////////////////
	// Q[ɓĂ
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		if( TF2_IsPlayerInCondition(client, TFCond_Taunting) && !g_ActionUse[client] )
		{
			/////////////////////////////////////////////////////////////////////
			// tbV
			/////////////////////////////////////////////////////////////////////
			SpawnFlash(client);
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// tbV
//
/////////////////////////////////////////////////////////////////////
stock SpawnFlash(client)
{

	/////////////////////////////////////////////////////////////////////
	// S{
	/////////////////////////////////////////////////////////////////////
	new ent = -1;
	new count = 0;
	new bomb[14];

	/////////////////////////////////////////////////////////////////////
	// Ƃ肠NA
	/////////////////////////////////////////////////////////////////////
	for( new i = 0; i < 14; i++)
	{
		bomb[i] = -1;
	}
	
	/////////////////////////////////////////////////////////////////////
	// TĂS擾
	/////////////////////////////////////////////////////////////////////
	while ((ent = FindEntityByClassname(ent, "tf_projectile_pipe_remote")) != -1)
	{
		// S̃I[i[
		new iOwner = GetEntDataEnt2(ent, FindSendPropInfo("CTFGrenadePipebombProjectile", "m_hThrower"));
		if(iOwner == client)
		{
			if(IsValidEntity(ent) )
			{
				bomb[count] = ent;
				count++;
			}		
		}
	}
	
	new Float:fBombPos[3];
	new Float:fVictimPos[3];
	new Float:dist;
	new maxclients = GetMaxClients();

	/////////////////////////////////////////////////////////////////////
	// Q`FbN
	/////////////////////////////////////////////////////////////////////
	for (new victim = 1; victim <= maxclients; victim++)
	{
		if( IsClientInGame(victim) && IsPlayerAlive(victim) )
		{
			/////////////////////////////////////////////////////////////////////
			// 炤͓̂GƎ
			/////////////////////////////////////////////////////////////////////
			if( GetClientTeam(victim) != GetClientTeam(client) || victim == client )
			{
				new blindPower = 0;
				new Float:blindTime = GetConVarFloat(g_CVarBlindTime);
				new Float:bonusTime = 0.0;

				/////////////////////////////////////////////////////////////////////
				// TĂS`FbN
				/////////////////////////////////////////////////////////////////////
				for( new i = 0; i < 14; i++)
				{
					if(IsValidEntity(bomb[i]))
					{
						/////////////////////////////////////////////////////////////////////
						// {ʒu
						/////////////////////////////////////////////////////////////////////
						GetEntPropVector(bomb[i], Prop_Data, "m_vecOrigin", fBombPos);
						/////////////////////////////////////////////////////////////////////
						// Q҈ʒu
						/////////////////////////////////////////////////////////////////////
						GetEntPropVector(victim, Prop_Data, "m_vecOrigin", fVictimPos);
						/////////////////////////////////////////////////////////////////////
						// {ƔQ҂̈ʒu
						/////////////////////////////////////////////////////////////////////
						dist = GetVectorDistanceMeter(fBombPos, fVictimPos);
						new HitEnt = -1;
						new Float:eyePos[3];		// Q҂̎_ʒu
						new Float:eyeAngles[3];		// Q҂̎_px
						new Float:bombAngles[3];	// Sւ̕
						/////////////////////////////////////////////////////////////////////
						// ڂ̈ʒuƊpx擾
						/////////////////////////////////////////////////////////////////////
						GetClientEyePosition(victim, eyePos); 
						GetClientEyeAngles(victim, eyeAngles);
						/////////////////////////////////////////////////////////////////////
						// Sւ̊px
						/////////////////////////////////////////////////////////////////////
						SubtractVectors(eyePos, fBombPos, bombAngles);
						GetVectorAngles(bombAngles, bombAngles);

						if( HitCheck( eyePos, bombAngles, fBombPos, MASK_SHOT, HitEnt, StickyFlashTraceFilter, 0 ) )
						{
							/////////////////////////////////////////////////////////////////////
							// Sɖڐʂ
							/////////////////////////////////////////////////////////////////////
							if( bomb[i] == HitEnt )
							{
								new power = 0;				// ̃p[
								
								if( AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_Front )
								{
									power = 255;
								}
								else if( AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_RightFront
								|| AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_LeftFront
								|| AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_Right
								|| AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_Left
								)
								{
									power = 128;
								}
								else if(AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_RightBack
								|| AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_LeftBack
								)
								{
									power = 64;
								}
								else if( AroundPosition:GetTargetAroundPos( victim, bomb[i] ) == AP_Back )
								{
									power = 32;
								}

								/////////////////////////////////////////////////////////////////////
								// ɂĂጸ
								/////////////////////////////////////////////////////////////////////
								if(dist < 4.0)
								{
									power = RoundFloat(power * 1.0);
								}
								else if( dist >= 4.0 && dist < 6.0 )
								{
									power = RoundFloat(power * 0.8);
								}
								else if( dist >= 6.0 && dist < 8.0 )
								{
									power = RoundFloat(power * 0.4);
								}
								else
								{
									power = RoundFloat(power * 0.2);
								}
								/////////////////////////////////////////////////////////////////////
								// 10mȏ͌ʂȂ
								/////////////////////////////////////////////////////////////////////
								if(dist > 10.0)
								{
									power = 0;
								}

								/////////////////////////////////////////////////////////////////////
								// vl
								/////////////////////////////////////////////////////////////////////
								blindPower += power;
								/////////////////////////////////////////////////////////////////////
								// ől
								/////////////////////////////////////////////////////////////////////
								if(blindPower > 255)
								{
									blindPower = 255;
								}
								
								/////////////////////////////////////////////////////////////////////
								// 
								/////////////////////////////////////////////////////////////////////
								if(GetEntProp(bomb[i], Prop_Send, "m_bCritical") == 1)
								{
									bonusTime += GetConVarFloat(g_CVarBlindTimeCriticalAdd) * (1 / dist);
								}				
								else
								{
									blindTime += GetConVarFloat(g_CVarBlindTimeNormalAdd) * (1 / dist);
								}									
							}
						}
					}
				}
				
				/////////////////////////////////////////////////////////////////////
				// ŏIIȖῂ
				/////////////////////////////////////////////////////////////////////
				if( g_FlashPower[victim] < blindPower )
				{
					g_FlashPower[victim] = blindPower;
					/////////////////////////////////////////////////////////////////////
					// ʓKp
					/////////////////////////////////////////////////////////////////////
					ScreenFade(victim, 255, 255, 255, g_FlashPower[victim], 1000000, IN);
					
					/////////////////////////////////////////////////////////////////////
					// A^C}[
					/////////////////////////////////////////////////////////////////////
					ClearTimer(g_FlashTimer[victim]);
					g_FlashTimer[victim] = CreateTimer(blindTime + bonusTime, Timer_FadeEnd, victim);					
				}

			}
		}
	}

	/////////////////////////////////////////////////////////////////////
	// S
	/////////////////////////////////////////////////////////////////////
	for( new i = 0; i < 14; i++)
	{
		if(IsValidEntity(bomb[i]))
		{
			//SetEntPropVector(bomb[i], Prop_Send, "m_angRotation", NULL_VECTOR);

			GetEntPropVector(bomb[i], Prop_Data, "m_vecOrigin", fBombPos);
			SpawnParticle( EFFECT_EXPLODE_SMOKE, 0.5, _, _, _, fBombPos);
			SpawnParticle( EFFECT_EXPLODE_DEBRIS, 0.5, _, _, _, fBombPos);
			SpawnParticle( EFFECT_EXPLODE_FLASH, 0.5, _, _, _, fBombPos);

			EmitSoundToAll(SOUND_BOMB_BANG, bomb[i], _, _, SND_CHANGEPITCH, 1.0, 200);
			EmitSoundToAll(SOUND_BOMB_BANG2, bomb[i], _, _, SND_CHANGEPITCH, 1.0, 120);
			AcceptEntityInput(bomb[i], "Kill");
		}
	}
	
}

/////////////////////////////////////////////////////////////////////
//
// g[XtB^
//
/////////////////////////////////////////////////////////////////////
public bool:StickyFlashTraceFilter( entity, contentsMask )
{
 	return entity > MAXPLAYERS;
}

/////////////////////////////////////////////////////////////////////
//
// tF[hAEg
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_FadeEnd(Handle:timer, any:client)
{
	g_FlashTimer[client] = INVALID_HANDLE;

	if( IsClientInGame(client) && IsPlayerAlive(client) )
	{
		ScreenFade(client, 255, 255, 255, g_FlashPower[client], 0, IN);
	}
	g_FlashPower[client] = 0;
}

/////////////////////////////////////////////////////////////////////
//
// ANVXbg
//
/////////////////////////////////////////////////////////////////////
public Action:Command_ActionItem(client, args)
{
	if( IsRunning() )
	{
		/////////////////////////////////////////////////////////////////////
		// ANVACegp
		/////////////////////////////////////////////////////////////////////
		g_ActionUse[client] = true;
	}
	return Plugin_Continue;
}