/////////////////////////////////////////////////////////////////////
// AreB[pbN
/////////////////////////////////////////////////////////////////////
#if defined _rmf_abilitybase_included
#endinput
#endif
#define _rmf_abilitybase_included

/////////////////////////////////////////////////////////////////////
// CN[h
/////////////////////////////////////////////////////////////////////
#include <sourcemod>
#include <sdktools>
#include <tf2>
#include <tf2_stocks>
#include "rmf/rmf_tf2cvar"
#include "rmf/rmf_tf2effect"
#include "rmf/rmf_tf2game"
#include "rmf/rmf_tf2player"
#include "rmf/rmf_tf2system"
#undef REQUIRE_PLUGIN 
#include "rmf/rmf_itemhelper"
#include "include/sdkhooks"

/////////////////////////////////////////////////////////////////////
//
// 񋓌^
//
/////////////////////////////////////////////////////////////////////
// Xbg̎
enum ItemSlotType
{
	IS_Primary,
	IS_Secondary,
	IS_Melee,
	IS_PDA,
	IS_PDA2,
	IS_Building,
	IS_Hat,
	IS_Action,
	IS_Misc,
	IS_Misc2
};
/////////////////////////////////////////////////////////////////////
//
// ϐ
//
/////////////////////////////////////////////////////////////////////
new String:g_abilityName[64] = "";
new Float:g_LastKeyCheckTime[MAXPLAYERS+1];				// Ō̃L[`FbN


/////////////////////////////////////////////////////////////////////
//
// AreBǉ
//
/////////////////////////////////////////////////////////////////////
public AddAbility( TFClassType:_classType )
{
	/////////////////////////////////////////////////////////////////////
	// ǗvOC
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// AreBpbNvOC
	/////////////////////////////////////////////////////////////////////
	new Handle:managePlugin = FindPluginByFile("RMFAbilityPack.smx");
	if( managePlugin != INVALID_HANDLE )
	{
		/////////////////////////////////////////////////////////////////////
		// AreBݒ
		/////////////////////////////////////////////////////////////////////
		decl String:fileName[64];
		GetPluginFilename(INVALID_HANDLE, fileName, sizeof( fileName ) );
		ReplaceString( fileName, sizeof( fileName ), ".smx", "");
		strcopy( g_abilityName, sizeof( g_abilityName ), fileName );
		
		/////////////////////////////////////////////////////////////////////
		// t@CǍ
		/////////////////////////////////////////////////////////////////////
		decl String:pharasesName[64];
		Format( pharasesName, sizeof( pharasesName ), "%s.phrases", g_abilityName);
		LoadTranslations( pharasesName );		
		
		/////////////////////////////////////////////////////////////////////
		// ֐Ăяo
		/////////////////////////////////////////////////////////////////////
		// ֐擾
		new Function:manageFunc = GetFunctionByName(managePlugin, "AddAbility");
		if( manageFunc != INVALID_FUNCTION )
		{
			new Handle:myHandle = GetMyHandle();
			Call_StartFunction( managePlugin, manageFunc );
			Call_PushCellRef( myHandle );
			Call_PushString( g_abilityName );
			Call_PushCell( _classType );			
			Call_Finish();
		}		
	}	
}


/////////////////////////////////////////////////////////////////////
//
// K{ACeo^
//
/////////////////////////////////////////////////////////////////////
public AddReqItems( const String:_itemName[], String:_removeBaseAttr[] )
{
	/////////////////////////////////////////////////////////////////////
	// ǗvOC
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// AreBpbNvOC
	/////////////////////////////////////////////////////////////////////
	new Handle:managePlugin = FindPluginByFile("RMFAbilityPack.smx");
	if( managePlugin != INVALID_HANDLE )
	{
		
		/////////////////////////////////////////////////////////////////////
		// OCfbNX擾
		/////////////////////////////////////////////////////////////////////
		new String:itemIndex[32]; 
		Format( itemIndex, sizeof( itemIndex ), "%d", GetItemDefIndexFromName( _itemName ));
		
		/////////////////////////////////////////////////////////////////////
		// ֐Ăяo
		/////////////////////////////////////////////////////////////////////
		// ֐擾
		new Function:manageFunc = GetFunctionByName(managePlugin, "AddReqItems");
		if( manageFunc != INVALID_FUNCTION )
		{
			Call_StartFunction( managePlugin, manageFunc );
			Call_PushString( g_abilityName );
			Call_PushString( itemIndex );
			Call_PushString( _removeBaseAttr );
			Call_Finish();
		}		
	}		
}

/////////////////////////////////////////////////////////////////////
//
// JX^Agr[go^
//
/////////////////////////////////////////////////////////////////////
stock AddCustomAttributes( ItemSlotType:_slotID, const String:_attributeName[], const String:_attributeAmount[] )
{
	/////////////////////////////////////////////////////////////////////
	// ǗvOC
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// AreBpbNvOC
	/////////////////////////////////////////////////////////////////////
	new Handle:managePlugin = FindPluginByFile("RMFAbilityPack.smx");
	if( managePlugin != INVALID_HANDLE )
	{
		
		/////////////////////////////////////////////////////////////////////
		// OCfbNX擾
		/////////////////////////////////////////////////////////////////////
		new String:attributeIndex[32]; 
		Format( attributeIndex, sizeof( attributeIndex ), "%d", GetAttributeIndexFromName( _attributeName ));
		
		
		/////////////////////////////////////////////////////////////////////
		// ֐Ăяo
		/////////////////////////////////////////////////////////////////////
		// ֐擾
		new Function:manageFunc = GetFunctionByName(managePlugin, "AddCustomAttributes");
		if( manageFunc != INVALID_FUNCTION )
		{
			Call_StartFunction( managePlugin, manageFunc );
			Call_PushString( g_abilityName );
			Call_PushCell( _:_slotID );
			Call_PushString( attributeIndex );			
			Call_PushString( _attributeAmount );			
			Call_Finish();
		}		
	}		
}

/////////////////////////////////////////////////////////////////////
//
// ̃vOCI𒆁H
//
/////////////////////////////////////////////////////////////////////
stock bool:IsSelectedAbility( client )
{
	/////////////////////////////////////////////////////////////////////
	// ǗvOC
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// AreBpbNvOC
	/////////////////////////////////////////////////////////////////////
	new Handle:managePlugin = FindPluginByFile("RMFAbilityPack.smx");
	if( managePlugin != INVALID_HANDLE )
	{
		/////////////////////////////////////////////////////////////////////
		// ֐Ăяo
		/////////////////////////////////////////////////////////////////////
		// ֐擾
		new Function:manageFunc = GetFunctionByName(managePlugin, "IsSelectedAbility");
		if( manageFunc != INVALID_FUNCTION )
		{
			new bool:returnValue = false;
			Call_StartFunction( managePlugin, manageFunc );
			Call_PushCell( client );
			Call_PushString( g_abilityName );
			Call_Finish( returnValue );
			return returnValue;
		}		
	}	
	
	return false;
}

/////////////////////////////////////////////////////////////////////
//
// L[͎ԕۑ
//
/////////////////////////////////////////////////////////////////////
stock SaveKeyTime( any:client )
{
	/////////////////////////////////////////////////////////////////////
	// NCAg`FbN
	/////////////////////////////////////////////////////////////////////
	if( IsValidClient( client, false) )
	{		
		g_LastKeyCheckTime[ client ] = GetGameTime();
	}
}
/////////////////////////////////////////////////////////////////////
//
// L[͉\`FbN
//
/////////////////////////////////////////////////////////////////////
stock bool:CheckElapsedTime( any:client, Float:time )
{
	/////////////////////////////////////////////////////////////////////
	// NCAg`FbN
	/////////////////////////////////////////////////////////////////////
	if( IsValidClient(client, false) )
	{	
		/////////////////////////////////////////////////////////////////////
		// ԃ`FbN
		/////////////////////////////////////////////////////////////////////
		if( GetGameTime() - g_LastKeyCheckTime[client] >= time)
		{
			SaveKeyTime( client );
			return true;
		}
	}
	return false;
}
