/////////////////////////////////////////////////////////////////////
//
// GtFNg֌W̊֐
//
/////////////////////////////////////////////////////////////////////
#if defined _rmf_tf2effects_included
#endinput
#endif
#define _rmf_tf2effects_included

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
// tF[h
/////////////////////////////////////////////////////////////////////
#define IN  (0x0001 | 0x0010)
#define OUT (0x0002 | 0x0008)

/////////////////////////////////////////////////////////////////////
//
// p[eBN
//
/////////////////////////////////////////////////////////////////////
stock _:SpawnParticle(	const String:particleName[],
						Float:durationTime = 0.0,
						bool:startSpawn = true,
						attachEnt = 0,
						const String:attachBone[] = "",
						Float:effectPos[3] = NULL_VECTOR,
						Float:effectAng[3] = NULL_VECTOR,
						Float:effectVel[3] = NULL_VECTOR)
{
	/////////////////////////////////////////////////////////////////////
	// ܂p[eBN
	/////////////////////////////////////////////////////////////////////
	new particle = CreateEntityByName("info_particle_system");
	if ( IsValidEdict( particle ) )
	{
		new Float:pos[3];
		new Float:ang[3];

		/////////////////////////////////////////////////////////////////////
		// ʒu({[ɕtȂƂ)
		/////////////////////////////////////////////////////////////////////
		if( StrEqual( attachBone, "" ) )
		{
			GetEntPropVector( attachEnt, Prop_Send, "m_vecOrigin", pos);
			AddVectors( pos, effectPos, pos );
			GetEntPropVector( attachEnt, Prop_Send, "m_angRotation", ang);
			AddVectors( ang, effectAng, ang );
			
			/////////////////////////////////////////////////////////////////////
			// ʒu̐ݒ
			/////////////////////////////////////////////////////////////////////
			TeleportEntity( particle, pos, ang, effectVel );
		}
		
	
		/////////////////////////////////////////////////////////////////////
		// eݒ
		/////////////////////////////////////////////////////////////////////
		new String:tName[32];
		GetEntPropString( attachEnt, Prop_Data, "m_iName", tName, sizeof( tName ) );
		DispatchKeyValue( particle, "targetname", "tf2particle");
		DispatchKeyValue( particle, "parentname", tName );
		DispatchKeyValue( particle, "effect_name", particleName );
		DispatchSpawn( particle );

		/////////////////////////////////////////////////////////////////////
		// GeBeBɃA^b`
		/////////////////////////////////////////////////////////////////////
		if( attachEnt != 0 )
		{
			SetVariantString("!activator");
			AcceptEntityInput(particle, "SetParent", attachEnt, particle, 0);
			
			/////////////////////////////////////////////////////////////////////
			// {[ɃA^b`
			/////////////////////////////////////////////////////////////////////
			if( !StrEqual( attachBone, "" ) )
			{
				SetVariantString(attachBone);
				AcceptEntityInput(particle, "SetParentAttachment", attachEnt, particle, 0);
				
				/////////////////////////////////////////////////////////////////////
				// ʒu̐ݒ
				/////////////////////////////////////////////////////////////////////
				TeleportEntity( particle, effectPos, effectAng, effectVel );
			}
		}
		ActivateEntity(particle);
		
		/////////////////////////////////////////////////////////////////////
		// ɍĐ
		/////////////////////////////////////////////////////////////////////
		if( startSpawn )
		{
			AcceptEntityInput(particle, "start");
		}
	
		/////////////////////////////////////////////////////////////////////
		// 폜^C}[
		/////////////////////////////////////////////////////////////////////
		if( durationTime > 0.0 )
		{
			CreateTimer( durationTime, RemoveParticle, particle );
		}
		
		/////////////////////////////////////////////////////////////////////
		// p[eBNԋp
		/////////////////////////////////////////////////////////////////////
		return particle;
	
	}
	return -1;
	
}
/////////////////////////////////////////////////////////////////////
//
// p[eBN~
//
/////////////////////////////////////////////////////////////////////
stock StopParticle(&particle)
{
	if ( particle != -1 )
	{
		if( IsValidEdict( particle ) )
		{
			new String:classname[32];
			GetEdictClassname( particle, classname, sizeof( classname ) );
			if( StrEqual( classname, "info_particle_system", false ) )
			{
				ActivateEntity( particle );
				AcceptEntityInput( particle, "stop" );
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// p[eBN폜
//
/////////////////////////////////////////////////////////////////////
stock DeleteParticle(&particle, Float:delay = 0.0)
{
	if ( particle != -1 )
	{
		if( IsValidEdict( particle ) )
		{
			new String:classname[32];
			GetEdictClassname( particle, classname, sizeof( classname ) );
			if( StrEqual( classname, "info_particle_system", false ) )
			{
				ActivateEntity( particle );
				AcceptEntityInput( particle, "stop" );
				CreateTimer( delay, RemoveParticle, particle );
				particle = -1;
			}
		}
	}
} 


////////////////////////////////////////
//
// p[eBN폜^C}[
//
////////////////////////////////////////
public Action:RemoveParticle( Handle:timer, any:particle )
{
	if ( IsValidEntity( particle) )
	{
		new String:classname[32];
		GetEdictClassname(particle, classname, sizeof(classname));
		if (StrEqual(classname, "info_particle_system", false))
		{
			AcceptEntityInput(particle, "stop");
			AcceptEntityInput(particle, "Kill");
			particle = -1;
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// TEp[eBN
//
/////////////////////////////////////////////////////////////////////
stock TE_Particle(String:Name[],
			Float:origin[3]=NULL_VECTOR,
			Float:start[3]=NULL_VECTOR,
			Float:angles[3]=NULL_VECTOR,
			entindex=-1,
			attachtype=-1,
			attachpoint=-1,
			bool:resetParticles=true)
{
	// find string table
	new tblidx = FindStringTable("ParticleEffectNames");
	if (tblidx==INVALID_STRING_TABLE) 
	{
		LogError("Could not find string table: ParticleEffectNames");
		return;
	}

	// find particle index
	new String:tmp[256];
	new count = GetStringTableNumStrings(tblidx);
	new stridx = INVALID_STRING_INDEX;
	new i;
	for (i=0; i<count; i++)
	{
		ReadStringTable(tblidx, i, tmp, sizeof(tmp));
		if (StrEqual(tmp, Name, false))
		{
			stridx = i;
			break;
		}
	}
	if (stridx==INVALID_STRING_INDEX)
	{
		LogError("Could not find particle: %s", Name);
		return;
	}

	TE_Start("TFParticleEffect");
	TE_WriteFloat("m_vecOrigin[0]", origin[0]);
	TE_WriteFloat("m_vecOrigin[1]", origin[1]);
	TE_WriteFloat("m_vecOrigin[2]", origin[2]);
	TE_WriteFloat("m_vecStart[0]", start[0]);
	TE_WriteFloat("m_vecStart[1]", start[1]);
	TE_WriteFloat("m_vecStart[2]", start[2]);
	TE_WriteVector("m_vecAngles", angles);
	TE_WriteNum("m_iParticleSystemIndex", stridx);
	if (entindex!=-1)
	{
		TE_WriteNum("entindex", entindex);
	}
	if (attachtype!=-1)
	{
		TE_WriteNum("m_iAttachType", attachtype);
	}
	if (attachpoint!=-1)
	{
		TE_WriteNum("m_iAttachmentPointIndex", attachpoint);
	}
	TE_WriteNum("m_bResetParticles", resetParticles ? 1 : 0);
}

/////////////////////////////////////////////////////////////////////
//
// XN[tF[h
//
/////////////////////////////////////////////////////////////////////
public ScreenFade(client, red, green, blue, alpha, duration, type)
{
	new Handle:msg
	
	msg = StartMessageOne("Fade", client)
	BfWriteShort(msg, 255)
	BfWriteShort(msg, duration)
	BfWriteShort(msg, type)
	BfWriteByte(msg, red)
	BfWriteByte(msg, green)
	BfWriteByte(msg, blue)	
	BfWriteByte(msg, alpha)
	EndMessage()
}